//
//  Guide.m
//  MoveCoachMobile
//
//  Created by Stephen Barrs on 8/29/12.
//

#import "Guide.h"
//#import "LocalNotification.h"

@implementation Guide {
    int oneWeek;
}
@synthesize startDate, endDate, duration, isActive, isComplete, currentSummary, summaries, progressCheckIn;

- (id)initWithIndex:(int)guideIndex
{
    self = [super init];
    if (self) {
        
        isActive = NO;
        index = guideIndex;
        
        oneWeek = 604800;
        
        progressCheckIn = nil;
        
        //here we need to detemine the index and set the span of time necessary to complete this guide
        switch (guideIndex) {
            case 0:
            case 1:
            case 2:
                duration = 1;
                break;
            case 3:
            case 4:  
            case 5:
            case 6:
            case 7:
            case 8:
            case 9:
            case 10:
                duration = 2;
                break;                
            default:
                break;
        }
        
        currentSummary = nil;
        summaries = [NSMutableArray array];
        
    }
    return self;
}

- (void) setStartDate {
    
    //set the start date to 'now'
    startDate = [NSDate date];
    
    if (oneWeek == 0) {
        oneWeek = 604800;
    }
    
//    if ([[LocalNotification notificationManager] testDataConfigIsOn]) {
//        //Sets lockouts to 1 or 2 minutes depending on duration (test only)
//        [self setEndDate:[NSDate dateWithTimeInterval:60 * duration sinceDate:startDate]];
//    } else {
//        // Sets lockouts to 1 and 2 weeks depending on duration
//        [self setEndDate:[NSDate dateWithTimeInterval:oneWeek * duration sinceDate:startDate]];
//    }
}


- (NSString *) description {
    
    return [NSString stringWithFormat:@"\nGuide index: %d\nduration: %d\nStart Date: %@\nEnd Date: %@\nis active: %u \nis complete: %u\n\n", index, duration, startDate, endDate, isActive, isComplete];
    
}

- (void) encodeWithCoder:(NSCoder *)aCoder {
    [aCoder encodeInt:index forKey:@"index"];
    [aCoder encodeObject:startDate forKey:@"startDate"];
    [aCoder encodeObject:endDate forKey:@"endDate"];
    [aCoder encodeInt:duration forKey:@"duration"];
    [aCoder encodeBool:isActive forKey:@"isActive"];
    [aCoder encodeBool:isComplete forKey:@"isComplete"];
    [aCoder encodeObject:currentSummary forKey:@"summary"];
    [aCoder encodeObject:summaries forKey:@"summaries"];
    [aCoder encodeInt:oneWeek forKey:@"oneWeek"];
    
    [aCoder encodeObject:progressCheckIn forKey:@"progressCheckIn"];
}

- (id) initWithCoder:(NSCoder *)aDecoder {
    
    self = [super init];
    if (self) {
        index = [aDecoder decodeIntForKey:@"index"];
        startDate = [aDecoder decodeObjectForKey:@"startDate"];
        endDate = [aDecoder decodeObjectForKey:@"endDate"];
        [self setDuration:[aDecoder decodeIntForKey:@"duration"]];
        [self setIsActive:[aDecoder decodeBoolForKey:@"isActive"]];
        [self setIsComplete:[aDecoder decodeBoolForKey:@"isComplete"]];
        [self setCurrentSummary:[aDecoder decodeObjectForKey:@"summary"]];
        [self setSummaries:[aDecoder decodeObjectForKey:@"summaries"]];
        oneWeek = [aDecoder decodeIntForKey:@"oneWeek"];
        progressCheckIn = [aDecoder decodeObjectForKey:@"progressCheckIn"];
    }
    
    return self;
}

- (void)summarizeGuide
{
    
    self.currentSummary = [[GuideSummary alloc]initWithGuideId:index];
    [self.summaries addObject:self.currentSummary];
}

@end

