//
//  ImageData.m
//  MoveCoachMobile
//
//  Created by Stephen Barrs on 8/8/13.
//

#import "ImageData.h"

@implementation ImageData

@synthesize image, date, compare;


//create with today as default date
- (id)initWithImage:(UIImage *)newImage {
    self = [super init];
    if (self) {
        if (newImage) {
            NSDate *today = [NSDate date];
            self = [self initWithImage:newImage andDate:today];
        }
    }
    return self;
}

//create with explicit date
- (id)initWithImage:(UIImage *)newImage andDate:(NSDate *)dateCreated
{
    self = [super init];
    if (self) {
        self.image = newImage;
        self.date = dateCreated;
        self.compare = NO;
    }
    return self;
}


- (void)encodeWithCoder:(NSCoder *)aCoder
{
    [aCoder encodeObject:image forKey:@"image"];
    [aCoder encodeObject:date forKey:@"date"];
    [aCoder encodeBool:compare forKey:@"compare"];
}

- (id)initWithCoder:(NSCoder *)aDecoder
{
    self = [super init];
    
    if (self) {
        [self setImage:[aDecoder decodeObjectForKey:@"image"]];
        [self setDate:[aDecoder decodeObjectForKey:@"date"]];
        [self setCompare:[aDecoder decodeBoolForKey:@"compare"]];
    }
    return self;
}


@end
