//
//  SlipEvent.m
//  MoveCoachMobile
//
//  Created by Stephen Barrs on 3/8/13.
//

#import "SlipEvent.h"

@implementation SlipEvent

@synthesize event, options, isBreakingEvent, indexOfBreakingOption;

- (id)initWithEvent:(NSString *)eventStr {
    self = [super init];
    if (self) {
    
        [self setEvent:eventStr];
        [self setIsBreakingEvent:NO];
        [self setIndexOfBreakingOption:1000];
        
        self.options = [NSMutableArray array];
        
    }
    return self;
}

- (id)init
{
    return [self initWithEvent:@""];
}


- (void) addOption:(NSString *)option {
    
    [[self options] addObject:option];    
}

- (void) addOption:(NSString *)option atIndex:(int)index{
    
        [[self options] insertObject:option atIndex:index];
   }

- (void) removeOption:(int)index {
    
    [[self options] removeObjectAtIndex:index];
}

- (void) encodeWithCoder:(NSCoder *)aCoder {
    
    [aCoder encodeObject:[self event] forKey:@"event"];
    [aCoder encodeObject:[self options] forKey:@"options"];
    [aCoder encodeBool:[self isBreakingEvent] forKey:@"isBreakingEvent"];
    [aCoder encodeInt:[self indexOfBreakingOption] forKey:@"indexOfBreakingOption"];
}

- (id) initWithCoder:(NSCoder *)aDecoder {
    
    self = [super init];
    
    if (self) {
        [self setEvent:[aDecoder decodeObjectForKey:@"event"]];
        [self setOptions:[aDecoder decodeObjectForKey:@"options"]];
        [self setIsBreakingEvent:[aDecoder decodeBoolForKey:@"isBreakingEvent"]];
        [self setIndexOfBreakingOption:[aDecoder decodeIntForKey:@"indexOfBreakingOption"]];

    }
    return self;
}




- (NSString *) description {
    
    NSString *desc=@"";
    NSMutableString *optionString = [[NSMutableString alloc] init];
    
    
    desc = [NSString stringWithFormat:@"event: %@\nisBreaking: %c  withIndex:%d\nwithOptions:\n", event, isBreakingEvent, indexOfBreakingOption];
    for (NSString *s in options) {
            [optionString appendString:[NSString stringWithFormat:@"\t%@", s]];
    }
    
    
    return [NSString stringWithFormat:@"%@%@", desc, optionString];
    
}



@end
