//
//  TriggerData.m
//  MoveCoachMobile
//
//  Created by Alex Morgan on 3/12/13.
//

#import "TriggerData.h"

@implementation TriggerData

@synthesize trigger, fixes, isBreakingTrigger, indexOfBreakingFix,fix;

- (id)initWithTrigger:(NSString *)triggerStr andFix:(NSString *)f
{
    self = [super init];
    if (self) {
        
        [self setTrigger:triggerStr];
       // [self setIsBreakingTrigger:NO];
       // [self setIndexOfBreakingFix:1000];
        [self setFix:f];
//        self.fixes = [NSMutableArray array];
        
    }
    return self;
}

- (id)initWithTrigger:(NSString *)triggerStr{
    self = [super init];
    if (self) {
        
        [self setTrigger:triggerStr];
        [self setIsBreakingTrigger:NO];
        [self setIndexOfBreakingFix:1000];
        
        self.fixes = [NSMutableArray array];
        
    }
    return self;
}

- (id)init
{
    return [self initWithTrigger:@""];
}


- (void) addFix:(NSString *)f forTrigger:(NSString *)trig {
    
    [[self fixes] addObject:f];
    [self setTrigger:trig];
}

- (void) addFix:(NSString *)f atIndex:(int)index{
    
    [[self fixes] insertObject:f atIndex:index];
}

- (void) removeFix:(int)index {
    
    [[self fixes] removeObjectAtIndex:index];
}

- (void) encodeWithCoder:(NSCoder *)aCoder {
    
    [aCoder encodeObject:[self trigger] forKey:@"trigger"];
    [aCoder encodeObject:[self fixes] forKey:@"fixes"];
    [aCoder encodeObject:[self fix] forKey:@"fix"];
    
    for (NSString *str in  fixes) {
        NSLog(@"option: %@", str);
    }
    
    [aCoder encodeBool:[self isBreakingTrigger] forKey:@"isBreakingTrigger"];
    [aCoder encodeInt:[self indexOfBreakingFix] forKey:@"indexOfBreakingFix"];
}

- (id) initWithCoder:(NSCoder *)aDecoder {
    
    self = [super init];
    
    if (self) {
        [self setTrigger:[aDecoder decodeObjectForKey:@"trigger"]];
        
        [self setFixes:[aDecoder decodeObjectForKey:@"fixes"]];
        [self setFix:[aDecoder decodeObjectForKey:@"fix"]];
        
        
        [self setIsBreakingTrigger:[aDecoder decodeBoolForKey:@"isBreakingTrigger"]];
        [self setIndexOfBreakingFix:[aDecoder decodeIntForKey:@"indexOfBreakingFix"]];
        
        for (NSString *str in  [self fixes]) {
            NSLog(@"option: %@", str);
        }
    }
    return self;
}

- (NSString *) description {
 
    return [NSString stringWithFormat:@"Trigger: %@, Fix: %@",self.trigger,self.fix];
/*    NSString *desc;
    NSMutableString *fixString;
    
    
    desc = [NSString stringWithFormat:@"trigger: %@\nisBreaking: %c  withIndex:%d\nwithFixes:\n", trigger, isBreakingTrigger, indexOfBreakingFix];
    for (NSString *s in fixes) {
        [fixString appendString:[NSString stringWithFormat:@"\t%@", s]];
    }
    
    
    return [NSString stringWithFormat:@"%@%@", desc, fixString];*/
    
}

@end
