//
//  WeightData.m
//  MoveCoachMobile
//
//  Created by Alex Morgan on 8/30/12.
//

#import "WeightData.h"
//#import "LocalNotification.h"
//#import "UserData.h"

@implementation WeightData

@synthesize userWeight, dateCreated;

- (id)initWithWeight:(float)w
{
    self = [super init];
    
    if (self) {
        if (w) {
            NSDate *today = [[NSDate alloc] init];
//            NSDate *today = [NSDate date];
            self = [self initWithWeight:w andDate:today];
        }
    }
    
    return self;
}
- (id)initWithWeight:(float)w andDate:(NSDate *)date
{
    self = [super init];
    
    if (self) {
    
        if (!date) {
            date = [NSDate date];
        }
        
        self.userWeight = w;
        self.dateCreated = date;
    }
 //   [[LocalNotification notificationManager] updateEntries:@"weight"];

    return self;
}


- (NSString *)description
{
    return [NSString stringWithFormat:@"\nWeight: %.1f    Date: %@",[self userWeight], [self dateCreated]];
}

- (void) encodeWithCoder:(NSCoder *)aCoder {
    
    [aCoder encodeObject:dateCreated forKey:@"dateCreated"];
    [aCoder encodeFloat:userWeight forKey:@"weight"];
}

- (id) initWithCoder:(NSCoder *)aDecoder {
    
    self = [super init];
    
    if (self) {
        [self setDateCreated:[aDecoder decodeObjectForKey:@"dateCreated"]];
        [self setUserWeight:[aDecoder decodeFloatForKey:@"weight"]];
    }
    return self;
}

@end
