require.config({
    shim: {
        'underscore': {
            exports: '_'
        },

        'backbone': {
            deps: ["underscore", "jquery"],
            exports: "Backbone"
        },

        'mockjax': {
            exports: 'mockjax'
        }

    },
    // <script src="js/utilities/jqm-config.js"></script>

    // Require.js allows us to configure shortcut alias
    paths: {
        jquery: '../lib/jquery-2.1.3.min',
        jquerymobile: '../lib/jquery.mobile-1.4.5.min',
        mockjax: '../lib/jquery.mockjax',
        underscore: '../lib/underscore-1.8.2',
        backbone: '../lib/backbone-1.1.2',
        loglevel: '../lib/loglevel',
        text: '../lib/text',
        localstorage: '../lib/backbone.localStorage',
        handlebars: '../lib/handlebars-v3.0.0',
        chart: '../lib/Chart',
        slideHelper: '../lib/jssor',
        slider: '../lib/jssor.slider',
        jsPDF: '../lib/jspdf.debug'
    }
});

/**
 * Load our app module and pass it to our definition function.
 * <p>
 * <b>NOTE: </b>'require' is typically used to load code in a top-level JavaScript file or within a module should you wish to
 * dynamically fetch dependencies. <br/> https://github.com/addyosmani/backbone-mobile-search
 * </p>
 *
 * @module main
 */
require(['backbone', 'localstorage', 'jquery', 'underscore', 'loglevel', 'chart', 'handlebars', 'jsPDF'], function(Backbone, LocalStorage, $, _, log, chart, Handlebars, jsPDF) {
    log.setLevel(log.levels.DEBUG);

    $(document).bind("mobileinit", function() {
        log.info('mobileinit');

isTesting = true;

		pageBack = false;

        // Disable jQM routing and component creation events
        // disable hash-routing
        $.mobile.hashListeningEnabled = false;
        // disable anchor-control
        $.mobile.linkBindingEnabled = false;
        // can cause calling object creation twice and back button issues are solved
        $.mobile.ajaxEnabled = false;

        // consider due to compatibility issues
        // not supported by all browsers  
        $.mobile.pushStateEnabled = false;
        // Solves phonegap issues with the back-button
        $.mobile.phonegapNavigationEnabled = true;

		//$.mobile.fixedtoolbar.prototype.options.tapToggle = false;
  		//$.mobile.fixedtoolbar.prototype.options.hideDuringFocus ="";

        // Remove page from DOM when it's being replaced
        $(document).on("pagecontainershow", function(event, ui) {
            if (ui.prevPage) {
                ui.prevPage.remove();
            }
         //   console.log ("current page: " + ui.toPage);
            //fix GuideChapterView object that loses these classes on page navigation
            $('.ui-page').addClass("ui-page-header-fixed ui-page-footer-fixed");
            
          //  $('.notThumbnail').removeClass("ui-li-has-thumb");
        });

		$(document).on("listviewcreate", function () {
         	$(".notThumbnail.ui-li-has-thumb", this).removeClass("ui-li-has-thumb");
      	});

        $(document).on("pagecontainerhide", function(event, ui) {
        	
        	var divPos = $('div').offset().top;
        			
           	if (divPos != 0) {
           			
 				$("body").animate({
    				  scrollTop: 0
  		   		}, 1000);
            }            	            	
           
        	
		});

		/*
		 * Stop main screen from scrolling since all content fits but it still scrolls a little bit
		 */
		$('body').on('touchmove', function(evt) {
    		var activePage = $.mobile.pageContainer.pagecontainer("getActivePage");
			var activePageId = activePage[0].id;
    		if (activePageId === "home-view") {
    			evt.preventDefault(); 

    		}
		});

        // Reset transition and direction properties if the button has set custom attributes.
        // BackBone router will still handle the actual transition and routing
        var defs = $.mobile.changePage.defaults;
        $(document).on('click', 'a[data-role="button"]', function() {

            var $this = $(this);

            if ($this.attr('data-transition')) {
                $.mobile.changePage.defaults.transition = $this.attr('data-transition');
            } else {
                // $.mobile.changePage.defaults.transition = defs.transition;
                $.mobile.changePage.defaults.transition = "slide";
            }

            if ($this.attr('data-direction')) {
                $.mobile.changePage.defaults.reverse = $this.attr('data-direction') == 'reverse';
            } else {
                $.mobile.changePage.defaults.reverse = false;
            }
        });
		
        // Handle back button since we turned off jQueryMobile handling of it.
        $(document).on('click', '.back', function(event) {
            window.history.back();
            pageBack = true;
            return false;
        });
    });

    Handlebars.registerHelper('isGuideLocked', function(status, options) {
  		if(status === "lock") {
    		return options.fn(this);
  		}
  		return options.inverse(this);
	});
    Handlebars.registerHelper('isGuideActive', function(status, options) {
  		if(status === "carat-r") {
    		return options.fn(this);
  		}
  		return options.inverse(this);
	});
    Handlebars.registerHelper('isGuideComplete', function(status, options) {
  		if(status === "check") {
    		return options.fn(this);
  		}
  		return options.inverse(this);
	});
	
	
    var onDeviceReady = function() {
        // Bootstrap data needed for the application.
        require(['models/UserData', 'collections/allGuides', 'routes/router', 'routes/HelpRouter', 'jquerymobile'], function(UserData, Guides, DefaultRouter, HelpRouter) {
            // Wait for the collections to be populated 1st since retrieving data from the server is asynchronous.
            $.when(UserData.deferred, Guides.deferred).done(function() {
                // Create application router.
                defaultRouter = new DefaultRouter();
                helpRouter = new HelpRouter();
                
                isTablet = true;
                var windowWidth = $(window).width();		     	
		     	if (windowWidth < 415) {
		     		isTablet = false;
		     	}                
				//unlockGuides();
                // Start backbone history.
                Backbone.history.start();
            });;
            
        });

    };
    //should below code be inside onDeviceReady function?
    // Wait for the 'deviceready' event if running on a device or simulator.
    if (typeof device != "undefined" && device.available) {
    	console.log('running on device');
    	//We may also want to set a global BOOL here so we can easily determine if we are on a device prior to accessing device specific features.
    	
        // The status bar plugin fixes problem (introduced with iOS7) with the status bar
        // overlaying the webview. Install plugin using: 'cordova plugin add org.apache.cordova.statusbar'
        //convert to number and do Maths here to support future versions
        // SJB - why not check >= 7 ?
        if ("iOS" == device.platform && ("7" == device.version.substring(0, 1) || "8" == device.version.substring(0, 1)) && StatusBar) {
        //if ("iOS" == device.platform && "7" == device.version.substring(0, 1) && StatusBar) {
            StatusBar.overlaysWebView(false);
            StatusBar.styleDefault();
        }

        document.addEventListener('deviceready', onDeviceReady, false);
    } else {
        // Running in web browser so just call the function.
        log.info ('running in browser');
        onDeviceReady();
    }

    dataMigrate = function() {
        
        console.log ("************* Migrating data from version 1**************");    
        
        
        //abstract this function to be reusable and populate a hash with key:objectName and value:jsonObject.
        //We should use the objects and then destroy them, and set a flag to say we dont need them anymore.
        
        console.log ("local file dir: " + cordova.file.documentsDirectory);
        var file = cordova.file.documentsDirectory + "initialData.json";
        
        window.resolveLocalFileSystemURL(file, resolveOnSuccess, resOnError);

            //Callback function when the file system uri has been resolved
            function resolveOnSuccess(fileEntry){

                console.log ("successfully resolved the file system with: ");

                fileEntry.file (function (file) {
                   
                   var reader = new FileReader();
                   
                   reader.onloadend = function (e) {
                       console.log ("Text is: " + this.result);
                       
                       var myJson = JSON.parse (this.result);
                       console.log ("JSON data: " + myJson.eulaComplete);
                       initialInfoJson = myJson;
                       

                   }
                   
                   reader.readAsText(file); 
                    
                });
            }
        
            function resOnError() {
                
                console.log ("Filed to reosolve the file: " + file);
            }
        
        
        
        
        
        
    }
});












