
/*
@property (nonatomic,strong)NSString *familyWeight;
1 - @property (nonatomic,strong)NSString *supportExpected;
1 - @property (nonatomic)float weightControlImportance;
@property (nonatomic)float activityDays;

1 - @property (nonatomic)float changeConfidence;

@property (nonatomic,strong)NSString *mealsAndSnacks;
@property (nonatomic,strong)NSString *consumeSugarDrinks;
@property (nonatomic,strong)NSString *consumeAlcohol;
@property (nonatomic,strong)NSString *activityTime;

//This Array property holds a list of NSStrings representing the issues a user has selected 'YES' to (by adding a checkmark in the UITableView).
1 - @property (nonatomic, strong) NSMutableArray *surveyIssuesArray;


- (void)toggleIssue:(NSString *)str;
- (void) removeAllIssues;

- (void)selectedAnswer:(NSString *)str question:(int)section; 
- (void)guide1GetReadySelectedAnswer:(NSString *)str question:(int)question;

- (void)sliderAnswer:(float)num question:(NSString *)question; 
*/

define(function(require) {
    var log = require("loglevel");

    var SurveyData = Backbone.Model.extend({
        localStorage: new Backbone.LocalStorage("SurveyData"),

        deferred: "",
        
		defaults: {
			"encouragementList":  [{ name: "A lot", value: "g1qel-1"}, 
        				    	   { name: "Somewhat", value: "g1qel-2"},
        				  		   { name: "Not at all", value: "g1qel-3"}],
        				    
			"issuesList":  [{ name: "Too much stress", value: "g1qil-01"}, 
        				    { name: "General unhappiness", value: "g1qil-02"},
        				  	{ name: "Depression", value: "g1qil-03"},
        				  	{ name: "Anxiety or Nervousness", value: "g1qil-04"},
        				  	{ name: "Family or relationship problems", value: "g1qil-05"},
        				  	{ name: "Bipolar disorder", value: "g1qil-06"},
        				  	{ name: "Schizophrenia", value: "g1qil-07"},
        				  	{ name: "PTSD", value: "g1qil-08"},
        				  	{ name: "OCD", value: "g1qil-09"},
        				  	{ name: "Eating disorder", value: "g1qil-10"},
        				  	{ name: "Tobacco use or Smoking", value: "g1qil-11"},
        				  	{ name: "Substance Abuse/Dependence", value: "g1qil-12"},
        				  	{ name: "None", value: "g1qil-13"}],
        				  	
        	"overweightReasonList":[{name: "Eating due to emotions/stress", value: "g1grorl-01"},
        							{name: "Family/Relationship problems", value: "g1grorl-02"},
        							{name: "Boredom", value: "g1grorl-03"},
        							{name: "Loneliness or loss of loved one", value: "g1grorl-04"},
        							{name: "Eating too much", value: "g1grorl-05"},
        							{name: "Poor food choices or habits", value: "g1grorl-06"},
        							{name: "Not enought physical activity", value: "g1grorl-07"},
        							{name: "Difficulty with self control", value: "g1grorl-08"},
        							{name: "Hungry all the time", value: "g1grorl-09"},
        							{name: "Feeling bad about myself", value: "g1grorl-10"},
        							{name: "Love to eat", value: "g1grorl-11"},
        							{name: "Quitting tobacco use", value: "g1grorl-12"},
        							{name: "Pregnancy/Childbirth", value: "g1grorl-13"},
        							{name: "Illness or injury", value: "g1grorl-14"},
        							{name: "Medications that effect weight", value: "g1grorl-15"},
        							{name: "Other", value: "g1grorl-16"},
        							{name: "None", value: "g1grorl-17"}],
        							
        	"eatingHabitObsticalList":[{name:"Eating food from restaurants, fast food places, convenience stores, vending machines", value: "g1grehol-01", checked: false},
        							   {name:"Person who prepares my food is uncooperative or unsupportive", value: "g1grehol-02", checked: false},
        							   {name:"Too much high Calorie food available at home or work", value: "g1grehol-03", checked: false},
        							   {name:"Too little time to prepare and eat healthy food", value: "g1grehol-04", checked: false},
        							   {name:"Too little money to buy healthy food", value: "g1grehol-05", checked: false},
        							   {name:"Feeling hungry much of the time", value: "g1grehol-06", checked: false},
        							   {name:"Used to eating a certain way", value: "g1grehol-07", checked: false},
        							   {name:"Difficulties such as stress or depression", value: "g1grehol-08", checked: false},
        							   {name:"Being with others who overeat", value: "g1grehol-09", checked: false},
        							   {name:"Don't know how", value: "g1grehol-10", checked: false},
        							   {name:"Other", value: "g1grehol-11", checked: false},
        							   {name:"None", value: "g1grehol-12", checked: false}],
        	
        	"paObsticalList":[{name:"Too little time", value:"g2grpao-01"},
        					  {name:"Too little money", value:"g2grpao-02"},
        					  {name:"Safety concerns", value:"g2grpao-03"},
        					  {name:"No place to walk or be active", value:"g2grpao-04"},
        					  {name:"No transportation", value:"g2grpao-05"},
        					  {name:"Lack of support or encouragement from others", value:"g2grpao-06"},
        					  {name:"Difficulties such as stress, depression, etc.", value:"g2grpao-07"},
        					  {name:"Do not like to exercise", value:"g2grpao-08"},
        					  {name:"Daily habits or routines that do not include exercise", value:"g2grpao-09"},
        					  {name:"Pain", value:"g2grpao-10"},
        					  {name:"Amputation", value:"g2grpao-11"},
        					  {name:"Back Problems", value:"g2grpao-12"},
        					  {name:"Arthritis", value:"g2grpao-13"},
        					  {name:"Muscular problems", value:"g2grpao-14"},
        					  {name:"Heart or lung disease", value:"g2grpao-15"},
        					  {name:"Joint problems", value:"g2grpao-16"},
        					  {name:"Spinal cord injury", value:"g2grpao-17"},
        					  {name:"Too tired", value:"g2grpao-18"},
        					  {name:"Job or work schedule", value:"g2grpao-19"},
        					  {name:"Other", value:"g2grpao-20"},
        					  {name:"None", value:"g2grpao-21"}],
        					 
        	"sodaList":  [{ name: "I do not drink juice, juice-drinks, or sugar-sweetened soda, tea or other beverages.", value: "g3grs-1"}, 
        				    	   { name: "1 or 2 cups, cans, small bottles or drink boxes per day.", value: "g3grs-2"},
        				  		   { name: "3 or more cups, cans, small bottles or drink boxes per day.", value: "g3grs-3"}],
        				  		
        	"alcoholList":  [{ name: "Yes", value: "g3gra-1"}, 
        				     { name: "No", value: "g3gra-2"}],
        				     
        	"bingeList":  [{ name: "Never", value: "g3grb-1"},
        				   { name: "Less than 1 time per week", value: "g3grb-2"},
        				   { name: "1 time per week", value: "g3grb-3"},
        				   { name: "2 to 4 times per week", value: "g3grb-4"}, 
        				   { name: "5 or more times per week", value: "g3grb-5"}],
        	
        	"mpaList":  [{ name: "0 minutes", value: "g4grmpa-1"},
        				 { name: "10 minutes", value: "g4grmpa-2"},
        				 { name: "20 minutes", value: "g4grmpa-3"},
        				 { name: "30 minutes", value: "g4grmpa-4"},
        				 { name: "40 minutes", value: "g4grmpa-5"},
        				 { name: "50 minutes", value: "g4grmpa-6"},
        				 { name: "60 minutes", value: "g4grmpa-7"},
        				 { name: "90 minutes", value: "g4grmpa-8"},
        				 { name: "120 minutes", value: "g4grmpa-9"},
        				 { name: "150 or greater minutes", value: "g4grmpa-10"}
        				   ],
        				   
        	
		},


        initialize: function() {
            // Fetch user data from local storage
            this.deferred = this.fetch({
                reset: true
            });

            this.on("reset", function(e) {
                this.deferred.resolve();
            });
        },

        parse: function(response) {
            log.debug(JSON.stringify(response));
            return response[0];
        },

        // Overriding Backbone 'clear' method since we don't want to delete the id
        // attribute.
        clear: function() {
            // reset 'checked' attribute of the lists
            var aCollection = this.get("encouragementList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
			aCollection = this.get("issuesList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("overweightReasonList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("eatingHabitObsticalList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("paObsticalList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("sodaList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("alcoholList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("bingeList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}
       		
       		aCollection = this.get("mpaList");
			for (i=0; i < aCollection.length; i++) {
				aCollection[i].checked = false;
       		}

            this.set({
                weightControlImportance: 5,
                changeConfidence: 5,
                paDays: 0,
                surveyIssues: undefined,
                overweightReasons: undefined,
                eatingHabits: undefined,
                paObsticals: undefined,
                soda: undefined,
                alcohol: undefined,
                binge: undefined,
                mpa: undefined
            });
        },

        reset: function() {
            log.debug("using test data.");

            this.set({
                weightControlImportance: 5,
                changeConfidence: 5,
                paDays: 5,
                supportExpected: 'Somewhat',
                surveyIssues: ['PTSD', 'OCD'],
                overweightReasons: ['Boredom', 'Love to eat'],
                eatingHabits: ['Used to eating a certain way', 'Other'],
                paObsticals: ['Too tired', 'Other']
            });

            // Save changes to local storage.
            this.save();
        }

    });

    var surveyData = new SurveyData();
    return surveyData;
});