define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/CurrentWeightEntryTemplate.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    var dateEntered;

    var wtClear = true;

	var textString = "";

    var wtArray = UserData.get("currentWeight");


    var TargetWeightEntryView = Backbone.View.extend({
        id: "currentWeightEntryView",

        templateName: "CurrentWeightEntryTemplate.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
               // "change #weightInput": "changeBaselineWeight"

               "click #doneButton": "changeBaselineWeight",
              "click #button1": "button1Select",
              "click #button2": "button2Select",
              "click #button3": "button3Select",
              "click #button4": "button4Select",
              "click #button5": "button5Select",
              "click #button6": "button6Select",
              "click #button7": "button7Select",
              "click #button8": "button8Select",
              "click #button9": "button9Select",
              "click #buttonDot": "buttonDotSelect",
              "click #button0": "button0Select",
              "click #buttonDelete": "buttonDeleteSelect"
              // "focusin #wtDate": "dateSelected"


           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);

		},

		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);

        	dateEntered = new Date();

        	this.$("#wtDate").replaceWith('<input id="wtDate" type="date" value="' + dateEntered + '" />');
            this.$el.html(compiled_template(this.model.toJSON()));

            wtClear = true;
            textString = "";

            if (!UserData.get("currentWeight")){
        	textString = UserData.get("initialWeight");
        	UserData.set("currentWeight",textString);
        	// UserData.add("currentWeight",textString);
        	UserData.save();
        }else{

        	textString = UserData.get("currentWeight");

        }

        if(UserData.get("initialWeight") === undefined){
        		textString = "";
        	}

            this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'>" + textString + "</span>");

          /*  this.$("#wtDate").datepicker({
        showOn: 'button',
        buttonText: 'Show Date'
    });*/

            return this;
		},

		changeBaselineWeight: function(){

            var baselineValue = textString;


             UserData.set("currentWeight", baselineValue);


             var dateEntered = this.$("#wtDate").val();

             if(dateEntered === ""){
             	dateEntered = new Date();
             }else{
             	dateEntered = new Date(dateEntered);
             }



             // alert("date Entered: " + dateEntered);

             var weights = [];

             if(UserData.get("weight")){
             	var pulledWeights = UserData.get("weight");

             	for(var i=0; i < pulledWeights.length; i++){
             		console.log(pulledWeights[i]);
             		weights[i] = pulledWeights[i];
             	}

             	weights[weights.length] = {wt: baselineValue, dt: dateEntered};


             }else{
             	weights[0] = {wt: baselineValue, dt: dateEntered};
             }

             for(var i=0; i < weights.length; i++){
             		console.log("weight: " + weights[i].wt + " lbs.  Date: " + weights[i].dt);

             	}
             	var weightLost = Number(weights[0].wt) - Number(weights[(weights.length - 1)].wt);

             	UserData.set("initialWeight",weights[0].wt);
             	UserData.set("firstWeight",weights[0].wt);
             	UserData.set("currentWeight",weights[(weights.length - 1)].wt);
             	UserData.set("weightLost",weightLost);

             	UserData.set("weight", weights);


			UserData.save();


		},
/*		dateSelected: function(){
			// dateEntered = new Date(this.$('#wtDate').val());

			var textValue = this.$('#wtDate').val();
            // UserData.set("dietGoalsCheckinDate", textValue);
            // UserData.save();
            console.log("date: " + textValue);

            // if ( 'undefined' == typeof window.plugins || 'undefined' == typeof window.plugins.calendar )
            // {
            	// alert( "No calendar found." );
            	// return;
            // }


            var dttm = textValue.split("T");
            // if blank (or invalid format [ie, no time]), check for existing event and delete
            // if ( dttm.length != 2 )
            // {
            	// console.log("invalid datetime format for new event");
	            // if ( calEventExists )
				// {
					// console.log("event exists, attempting to delete event");
					// window.plugins.calendar.deleteEvent(calEventTitle, null, null,origStartDate,origEndDate,success,error);
				  	// // window.plugins.calendar.modifyEvent(calEventTitle, null, null,origStartDate,origEndDate,
				  										// // calEventTitle,null,calEventNotes,startDate,endDate,success,error);
					// console.log("diet event deleted");
				// }
//
            	// return;
            // }
            var dt = dttm[0];
            var tm = dttm[1];

            var dtvals = dt.split("-");
            var yr = dtvals[0];
            var mo = dtvals[1] -1;  // months start at 0
            var dy = dtvals[2];

            var tmvals = tm.split(":");
            var hr = tmvals[0];
            var mn = tmvals[1];

			dateEntered = new Date(yr,mo,dy,hr, mn    ,0,0,0); // beware: month 0 = january, 11 = december
  			// var endDate   = new Date(yr,mo,dy,hr,+mn +10,0,0,0); // minutes roll over - tested on ios

			// don't delete if same date/time as orig (no change to checkin date)
  			// if ( calEventExists && (startDate - origStartDate == 0) )
  			// {
  				// // same checkin date, and event already exists, so don't do anything
  				// console.log("same checkin date, event exists, doing nothing");
  				// return;
  			// }


  			var success = function(message)
  			{
  				var eventType = (calEventExists) ? "deleted" : "created";
  				console.log("*** SUCCESS: Calendar event " + eventType + ": " + JSON.stringify(message));
  			};
  			var error = function(message) { console.log("** FAIL ** Calendar event failed: " + message); };

			// rather than modifying event, delete and add new so reminders get set correctly.
			if ( calEventExists )
			{
				console.log("event exists, attempting to delete event");
				window.plugins.calendar.deleteEvent(calEventTitle, null, null,origStartDate,origEndDate,success,error);
			  	// window.plugins.calendar.modifyEvent(calEventTitle, null, null,origStartDate,origEndDate,
			  										// calEventTitle,null,calEventNotes,startDate,endDate,success,error);
				console.log("diet event deleted");
			}

			console.log("creating event: " + startDate + ", " + endDate);
  			var calOptions = window.plugins.calendar.getCalendarOptions(); // grab the defaults
  			calOptions.firstReminderMinutes = 0;  // at time of event
  			// second reminder is halfway.  find the number of days in between and convert to minutes.
  			// don't find minutes between, because the reminder should be same time of day as event.
  			var today = new Date();

  			var numDays = Math.ceil( (startDate - today) / 86400000 );
  			console.log("days: " + numDays );

  			// if there's at least 2 days before, set a second alarm halfway
  			if ( numDays >= 2 )
  			{
  				console.log("adding second reminder: " + Math.floor(numDays / 2));
				calOptions.secondReminderMinutes = Math.floor(numDays / 2) * 1440;
  			}
			else
			{
				console.log("not creating second reminder");
				calOptions.secondReminderMinutes = null;
			}

		},*/
		button1Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('1');

			textString = textString + "1";
			console.log("text value: " + textString);
		},
		button2Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('2');
			textString = textString + "2";
			console.log("text value: " + textString);
		},
		button3Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('3');
			textString = textString + "3";
			console.log("text value: " + textString);
		},
		button4Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('4');
			textString = textString + "4";
			console.log("text value: " + textString);
		},
		button5Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('5');
			textString = textString + "5";
			console.log("text value: " + textString);
		},
		button6Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('6');
			textString = textString + "6";
			console.log("text value: " + textString);
		},
		button7Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('7');
			textString = textString + "7";
			console.log("text value: " + textString);
		},
		button8Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('8');
			textString = textString + "8";
			console.log("text value: " + textString);
		},
		button9Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('9');
			textString = textString + "9";
			console.log("text value: " + textString);
		},
        buttonDotSelect: function(){
        	if(wtClear === true || textString.length === 0){
				wtClear = true;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}else{
			var text = this.$('#lbsDisplay').append('.');
			textString = textString + ".";
			}
			console.log("text value: " + textString);
		},
		button0Select: function(){
			if(wtClear === true || textString.length === 0){
				wtClear = true;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}else{
			var text = this.$('#lbsDisplay').append('0');
			textString = textString + "0";
			}
			console.log("text value: " + textString);
		},
		buttonDeleteSelect: function(){
			// var text = UserData.get("initialPercentToLose");
			wtClear = false;
			textString = textString.substring(0, textString.length-1);

			console.log("text value: " + textString);

			this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'>" + textString + "</span>");

		}
    });

    return TargetWeightEntryView;
});
