define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G1GetReady.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for Guide 1 Quesionnaire
    var G1GetReadyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g1GetReadyView",


        events: {
            'click #surveyComplete': 'storeSurveyData',
            'change #g1grehol-01': 'ehOtherClicked',
            'change #g1grehol-02': 'ehOtherClicked',
            'change #g1grehol-03': 'ehOtherClicked',
            'change #g1grehol-04': 'ehOtherClicked',
            'change #g1grehol-05': 'ehOtherClicked',
            'change #g1grehol-06': 'ehOtherClicked',
            'change #g1grehol-07': 'ehOtherClicked',
            'change #g1grehol-08': 'ehOtherClicked',
            'change #g1grehol-09': 'ehOtherClicked',
            'change #g1grehol-10': 'ehOtherClicked',
            'change #g1grehol-11': 'ehOtherClicked',
            'change #g1grehol-12': 'ehNoneClicked',
            'change #g1grorl-01': 'owOtherClicked',
            'change #g1grorl-02': 'owOtherClicked',
            'change #g1grorl-03': 'owOtherClicked',
            'change #g1grorl-04': 'owOtherClicked',
            'change #g1grorl-05': 'owOtherClicked',
            'change #g1grorl-06': 'owOtherClicked',
            'change #g1grorl-07': 'owOtherClicked',
            'change #g1grorl-08': 'owOtherClicked',
            'change #g1grorl-09': 'owOtherClicked',
            'change #g1grorl-10': 'owOtherClicked',
            'change #g1grorl-11': 'owOtherClicked',
            'change #g1grorl-12': 'owOtherClicked',
            'change #g1grorl-13': 'owOtherClicked',
            'change #g1grorl-14': 'owOtherClicked',
            'change #g1grorl-15': 'owOtherClicked',
            'change #g1grorl-16': 'owOtherClicked',
            'change #g1grorl-17': 'owNoneClicked'
        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            return this;
        },

        owNoneClicked: function(){

	this.$('#g1grorl-01').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-02').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-03').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-04').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-05').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-06').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-07').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-08').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-09').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-10').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-11').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-12').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-13').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-14').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-15').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-16').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grorl-17').attr("checked", true).checkboxradio('refresh');


        },
        owOtherClicked: function(){

	this.$('#g1grorl-17').attr("checked", false).checkboxradio('refresh');

        },
        ehNoneClicked: function(){

	this.$('#g1grehol-01').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-02').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-03').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-04').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-05').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-06').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-07').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-08').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-09').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-10').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-11').attr("checked", false).checkboxradio('refresh');
	this.$('#g1grehol-12').attr("checked", true).checkboxradio('refresh');

        },
        ehOtherClicked: function(){

	this.$('#g1grehol-12').attr("checked", false).checkboxradio('refresh');

        },

        storeSurveyData: function() {

			// record the selected reasons for being overweight
			var reasonField = $("#overweightReasonListFieldSet input:checked");
            var selectedReasons = [];
            for (i=0; i < reasonField.length; i++)
            {
                selectedReasons[i] = reasonField[i].value;
            }
            SurveyData.set("overweightReasons", selectedReasons);

            // there has to be a better way to do this
			// recording what was selected into the main issuesList
			// so it can be displayed as checked
			var reasonsKey;	// more performant?
			var reasons = SurveyData.get("overweightReasonList");
			for (i=0; i < reasons.length; i++)
			{
				reasons[i].checked = false;
				reasonsKey = reasons[i].name;
	            for (j=0; j < selectedReasons.length; j++)
	            {
	            	if (selectedReasons[j] == reasonsKey)
					{
						reasons[i].checked = true;
						break;
					}
	       		}
            }


            // record the selected obsticales to changing eating habits
			var habitField = $("#eatingHabitObsticalListFieldSet input:checked");
            var selectedHabits = [];
            for (i=0; i < habitField.length; i++)
            {
                selectedHabits[i] = habitField[i].value;
            }
            SurveyData.set("eatingHabits", selectedHabits);

            // there has to be a better way to do this
			// recording what was selected into the main issuesList
			// so it can be displayed as checked
			var habitsKey;	// more performant?
			var habits = SurveyData.get("eatingHabitObsticalList");
			for (i=0; i < habits.length; i++)
			{
				habits[i].checked = false;
				habitsKey = habits[i].name;
	            for (j=0; j < selectedHabits.length; j++)
	            {
	            	if (selectedHabits[j] == habitsKey)
					{
						habits[i].checked = true;
						break;
					}
	       		}
            }

            SurveyData.save();
			Guides.get(1).save("getReadyComplete", "check");
			Backbone.history.history.back();

//             defaultRouter.navigate("#guide/1", {
//                 trigger: true, replace:true
//             });
        }
    });

    return G1GetReadyView;
});
