define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        //GuidesCollection = require("collections/allGuides"),
        template = require("text!templates/G2Ch1_calRange.html"),
        UserData = require("models/UserData");;

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	Handlebars.registerHelper('getBackgroundColor', function(lowVal, highVal) {

		currentWeight = UserData.get("currentWeight");

		if (currentWeight >= lowVal && currentWeight <= highVal) {
			return "rgb(57,137,255)";
		} else {
			return "white";
		}

	});

	Handlebars.registerHelper('getTextColor', function(lowVal, highVal) {

		currentWeight = UserData.get("currentWeight");

		console.log ("current weight: " + currentWeight);

		if (currentWeight >= lowVal && currentWeight <= highVal) {
			return "white";
		} else {
			return "black";
		}

	});

    // The view for a single model view, which is one guide
    G2Ch1_calRangeView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g2Ch1_calRangeView",

        render: function(args) {

            $(this.el).html(compiled_template(this.model.toJSON()));

            if(UserData.get("currentGuide")){
            	this.$('#runtimeGeneratedHeader').replaceWith('<div id="runtimeGeneratedHeader" data-role="header" data-position="fixed">\
	<h1>Calorie Range</h1>\
	<a href="#" data-icon="back" class="back ui-btn-left" data-role="button" id="back" data-rel="back" data-direction="reverse">Back</a>\
</div>');
            }


            return this;
        }
    });

    return G2Ch1_calRangeView;
});
