define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G4GetReady.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for Guide 1 Quesionnaire
    var G4GetReadyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g4GetReadyView",


        events: {
            'click #surveyComplete': 'storeSurveyData',
            'change #slider-1': 'slider1change'


        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            var value1 = 0;

            if(SurveyData.get("paDays")){
            	value1 = SurveyData.get("paDays");
            }

            this.$('#paDaysText').replaceWith('<p id="paDaysText" style="margin-left: auto; margin-right: auto;width: 10%">' + value1 + '</p>');

            return this;
        },
        slider1change: function() {
        	var value = this.$('#slider-1').val();
        	this.$('#paDaysText').replaceWith('<p id="paDaysText" style="margin-left: auto; margin-right: auto;width: 10%">' + value + '</p>');
        },


        storeSurveyData: function() {
            // Save changes to local storage.

            var paDays = this.$('#slider-1').val();
            SurveyData.set("paDays", paDays);



			// record the selected support/encouragement value, if any
			var mpa = $("#mpaListFieldSet input:checked").val();
            SurveyData.set("mpa", mpa);

			// recording what was selected into main encouragementList
			// so it can be displayed as selected
			var mpaField = $("#mpaListFieldSet input:checked")[0];
			if (typeof mpaField != 'undefined')
			{
				var efKey = mpaField.id;
				var enList = SurveyData.get("mpaList");
				for (i=0; i < enList.length; i++)
				{
                	if (enList[i].value == efKey)
					{
						enList[i].checked = true;
					}
					else
					{
						enList[i].checked = false;
					}
           		}
			}


            SurveyData.save();
			Guides.get(4).save("getReadyComplete", "check");

			Backbone.history.history.back();


        }
    });

    return G4GetReadyView;
});
