define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G6C1ReductionOptions.html");


var foodValue;
    // Compile the template once.
    var compiled_template = Handlebars.compile(template);


    // The view for Guide 1 Quesionnaire
    var G6C1ReductionOptionsView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g6C1ReductionOptionsView",


        events: {
            'click #healthyFoodButton': 'generateReport',
            'click #entryCompleteButton': 'recordSolution'

        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));
            // $(this.el).attr('data-role', 'page');



            if(UserData.get("G6C1CurrentReductionType") === "Frequency"){
            	this.$("#substituteText").hide();
            	this.$("#amountText").hide();
            	this.$("#healthyFoodButton").hide();
            }else if(UserData.get("G6C1CurrentReductionType") === "Amount"){
            	this.$("#substituteText").hide();
            	this.$("#frequencyText").hide();
            	this.$("#healthyFoodButton").hide();
            }else if(UserData.get("G6C1CurrentReductionType") === "Substitution"){
            	this.$("#amountText").hide();
            	this.$("#frequencyText").hide();
            }

            return this;
        },
        recordSolution: function(){
        	var enteredText = this.$("#fattyFoodSolution").val();

        	var subtitle;
        	var foodName = UserData.get("G6C1CurrentFood");

        	if(UserData.get("G6C1CurrentReductionType") === "Frequency"){
            	subtitle = "Reduce Frequency to: " + enteredText;
            }else if(UserData.get("G6C1CurrentReductionType") === "Amount"){
            	subtitle = "Reduce Amount to: " + enteredText;
            }else if(UserData.get("G6C1CurrentReductionType") === "Substitution"){
            	subtitle = "Substitution: " + enteredText;
            }

            console.log(foodName + "\n" + subtitle);

            var ffEntry = [];

             if(UserData.get("G6C1FattyFoodEntrys")){
             	var pulledFattyFood = UserData.get("G6C1FattyFoodEntrys");

             	for(var i=0; i < pulledFattyFood.length; i++){
             		console.log(pulledFattyFood[i]);
             		ffEntry[i] = pulledFattyFood[i];
             	}

             	ffEntry[ffEntry.length] = {ffName: foodName, subtitle: subtitle};


             }else{
             	ffEntry[0] = {ffName: foodName, subtitle: subtitle};
             }

             for(var i=0; i < ffEntry.length; i++){
             		console.log("Food Name: " + ffEntry[i].ffName + "   Subtitle: " + ffEntry[i].subtitle);

             	}

             	UserData.set("G6C1FattyFoodEntrys", ffEntry);


			UserData.save();

            Backbone.history.history.back();

        },

        generateReport: function() {

            var message = "Turkey bacon, sausage, or franks\nCheese/Cottage cheese (low-fat)\nLight dressing/butter spray\nFruit\nGrilled, roasted or smoked meats\nLow-fat yogurt or Low-fat/skim milk\nVeggie pizza with low-fat cheese\nSteamed brown rice\nSherbet - Sorbet\nStir fry with lean meat\nGrilled, steamed or raw veggies\nVegetable pasta salad";
				navigator.notification.alert(
                message,    // message
                null,       // callback
                "Healthy Alternatives", // title
                'OK'        // buttonName
            );


        }
    });

    return G6C1ReductionOptionsView;
});
