define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G8C3AllActivities.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var selected_index;

    // The view for Guide 1 Quesionnaire
    var G8C1MakePlanView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g8C3AllActivitiesView",


        events: {

            'change #activityButton': 'activityEntry',
            'change #timeButton': 'timeEntry',
            'swipeleft ul#activityList li#deletableCells': 'getIndex',
            'swiperight ul#activityList li#deletableCells': 'getIndex'


        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));

            var planEntry = [];

             if(UserData.get("G8C3ActivityEntrys")){
             	var pulledPlan = UserData.get("G8C3ActivityEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}


             	for(var i=0; i < planEntry.length; i++){

             		this.$("#activityList").append('<li id="deletableCells"><h2 id="textString">' + planEntry[i].planName + '</h2><p>' + planEntry[i].subtitle + ' Minutes</p></li>');

             	}


             }


             	UserData.set("G8C3ActivityEntrys", planEntry);

             	UserData.save();


            return this;
        },
        getIndex: function(ev){

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index();

        	var planEntry = [];

        	if(UserData.get("G8C3ActivityEntrys").length > 0){
        		var pulledPlan = UserData.get("G8C3ActivityEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}



             }

        	var titleString = 'Are you sure you want to delete ' + planEntry[selected_index - 1].planName + '?';

             	function onConfirm(buttonIndex) {
  					  if(buttonIndex === 1){

             	planEntry.splice(selected_index - 1,1);

             	UserData.set("G8C3ActivityEntrys",planEntry);
             	UserData.save();


             	$(ev.currentTarget).remove();

					}
					}


				navigator.notification.confirm(
    				' ', // message
     				onConfirm,            // callback to invoke with index of button pressed
    				titleString,           // title
    				['Yes','No']     // buttonLabels
					);


        },
        timeEntry: function(){
        	
        	setTimeout(function(){

				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#timeButton";
       				var listID = "#timeList";

					var value = this.$(textFieldID).val();

					if (value != "") {

						this.$(textFieldID).val('');
				
					var enteredMin = value;

        			if($.isNumeric(enteredMin)){
        			UserData.set("G8C3CurrentTime",value);
        			UserData.save();

        			// save to array
        			var planEntry = [];

             if(UserData.get("G8C3ActivityEntrys")){
             	var pulledPlan = UserData.get("G8C3ActivityEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}


             	planEntry[planEntry.length] = {planName: UserData.get("G8C3CurrentActivity"), subtitle: UserData.get("G8C3CurrentTime")};
             }else{
             	planEntry[0] = {planName: UserData.get("G8C3CurrentActivity"), subtitle: UserData.get("G8C3CurrentTime")};
             }

             		var plan = UserData.get("G8C3CurrentActivity");
             		var reward = UserData.get("G8C3CurrentTime");

             	this.$("#activityList").append('<li id="deletableCells" style="background-color: white; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgba(0,0,0,0.1);border-top-width: 1px; border-top-style: solid; border-top-color: rgba(0,0,0,0.1);"><h2 id="textString" style="margin-left:15px;">' + plan + '</h2><p style="margin-left:15px;">' + reward + ' Minutes</p></li>');

             	UserData.set("G8C3ActivityEntrys", planEntry);

             	UserData.save();

        		}

					this.$("#timeEntry").hide();
        			
        			this.$("#activityEntry").show("slow");
        			
        			this.$("#activityList").listview("refresh");
					}
					
				}
				

				}, 100);
        	
        },
        activityEntry: function(){
        	
        	setTimeout(function(){
        	if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#activityButton";
       				var listID = "#activityList";

					var value = this.$(textFieldID).val();

					if (value != "") {
						
						this.$(textFieldID).val('');
						
						UserData.set("G8C3CurrentActivity",value);
        			UserData.save();
        			this.$("#activityEntry").hide();
        			this.$("#timeEntry").show("slow");
						
						}
					
				}
				

				}, 100);

        }
    });

    return G8C1MakePlanView;
});
