define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/MCAEntry.html");

        var compiled_template = Handlebars.compile(template);

        var textString = "0";

        // if (UserData.get("mcaValue")){
        	// textString = UserData.get("mcaValue");
        // }

        	var rateValue = UserData.get("initialWeightLossRange");

			// calorie calculations
			var baselineWeight = UserData.get("initialWeight");

			var minGoal = 1200;
   			 var maxGoal = 3500;
   			 var goalCal = 1200;

 			   var currentWeight = Number(baselineWeight);
 		   var lossRate = Number(rateValue);
//
    // var lossRate = UserData.get("initialWeightLossRange");
//
    if (currentWeight < 200) {
        minGoal = 1200;
        maxGoal = 1500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 226) {
        minGoal = 1500;
        maxGoal = 1800;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 251) {
        minGoal = 1800;
        maxGoal = 2000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 301) {
        minGoal = 2000;
        maxGoal = 2500;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else if (currentWeight < 351) {
        minGoal = 2500;
        maxGoal = 3000;
        goalCal = minGoal + ((maxGoal - minGoal)*((lossRate-2)/(-2)));
    } else {
        minGoal = 3000;
        maxGoal = 3500;
        goalCal = minGoal + ((maxGoal - minGoal)*(lossRate/2));
    }

        //

    return Backbone.View.extend({
        id: "mcaEntryView",

        templateName: "MCAEntry.html",

           events: {

              "click #doneButton": "doneSelect",
              "change #mcaSelect": "changeMCA"

           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);



		},

        render: function() {
            this.$el.html(template);
            
            goalCal = UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight"));

            this.$('#calGoal').replaceWith('<span id="calGoal">' + goalCal + '</span>');
            
            if(!UserData.get("mcaValue")){
            	UserData.set("mcaValue", 0);
            	UserData.save();
            }
            
            var mcaValue = Number(UserData.get("mcaValue"));
            
            if (mcaValue < -450) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500" selected="selected">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -400) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450" selected="selected">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -350) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400" selected="selected">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -300) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350" selected="selected">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -250) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300" selected="selected">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -200) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250" selected="selected">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -150) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200" selected="selected">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -100) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150" selected="selected">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < -50) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100" selected="selected">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 0) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50" selected="selected">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 50) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0" selected="selected">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 100) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50" selected="selected">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 150) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100" selected="selected">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 200) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150" selected="selected">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 250) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200" selected="selected">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 300) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250" selected="selected">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 350) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300" selected="selected">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 400) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350" selected="selected">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 450) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400" selected="selected">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else if (mcaValue < 500) {
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450" selected="selected">450 Calories</option>\
				<option value="500">500 Calories</option>\
			</select>');
			}else{
            this.$('#mcaSelect').replaceWith('<select name="mcaSelect" id="mcaSelect">\
				<option value="-500">-500 Calories</option>\
				<option value="-450">-450 Calories</option>\
				<option value="-400">-400 Calories</option>\
				<option value="-350">-350 Calories</option>\
				<option value="-300">-300 Calories</option>\
				<option value="-250">-250 Calories</option>\
				<option value="-200">-200 Calories</option>\
				<option value="-150">-150 Calories</option>\
				<option value="-100">-100 Calories</option>\
				<option value="-50">-50 Calories</option>\
				<option value="0">0 Calories</option>\
				<option value="50">50 Calories</option>\
				<option value="100">100 Calories</option>\
				<option value="150">150 Calories</option>\
				<option value="200">200 Calories</option>\
				<option value="250">250 Calories</option>\
				<option value="300">300 Calories</option>\
				<option value="350">350 Calories</option>\
				<option value="400">400 Calories</option>\
				<option value="450">450 Calories</option>\
				<option value="500" selected="selected">500 Calories</option>\
			</select>');
			}
			
			textString = mcaValue;


            return this;
        },
        doneSelect: function(){
			

		    goalCal = Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight"))) + Number(textString);
    
   			if(goalCal < 1200){
   				
   				textString = Number(1200) - Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight")));
   				
    			goalCal = 1200;
    		}

   
			goalCal = Number(goalCal).toFixed(0);
			// set and save
			UserData.set("mcaValue", textString);
			// UserData.set("initialWeightLossRange", rateValue);
             // UserData.set("goalReachedDate", dateString);
             UserData.set("dailyCalorieGoal", goalCal);

             UserData.save();
		},
		changeMCA: function(){
			textString = this.$("#mcaSelect").val();
			
			/*goalCal = Number(textString) + Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight")));
	
			if(goalCal < 1200){
    			goalCal = 1200;
    		}
    		
			UserData.set("dailyCalorieGoal", goalCal);

             UserData.save();*/
             
             goalCal = Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight"))) + Number(textString);
    
   			if(goalCal < 1200){
   				
   				textString = Number(1200) - Number(UserData.calculateCalorieGoal(UserData.get("initialWeightLossRange"),UserData.get("currentWeight")));
   				
    			goalCal = 1200;
    		}

   
			goalCal = Number(goalCal).toFixed(0);
			// set and save
			UserData.set("mcaValue", textString);
			// UserData.set("initialWeightLossRange", rateValue);
             // UserData.set("goalReachedDate", dateString);
             UserData.set("dailyCalorieGoal", goalCal);

             UserData.save();

			// UserData.set("initialWeightLossRange", rateValue);
			// UserData.save();
		}
    });
});
