define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        CalendarModel = require("models/CalendarEventModel"),
        template = require("text!templates/physicalGoals.html");

    var compiled_template = Handlebars.compile(template);

    var mcmCalendar = null;
	var calEventTitle = "MOVE!Coach Physical Activity Goal Check";
	var calEventNotes = "movecoachmobile://physicalActivityGoalEvent";


	var PhysicalGoalsView = Backbone.View.extend({
        id: "physicalGoalsView",

         events: {
              "change #pasg1": "saveGoalData",
              "change #pasg2": "saveGoalData",
              "focusout #pasgcid": "createCheckinEvent",
              "focusin #pasgcid": "findCheckinEvent"
         },

		initialize: function() {
			console.log ("initializing physical goals view: " + this);
		},

		render: function() {
			log.debug ("calling render in physical goals view");

            this.$el.html(compiled_template(this.model.toJSON()));
            return this;
		},

		saveGoalData: function() {
			var textValue = this.$('#pasg1').val();
            UserData.set("paSmartGoal1", textValue);
			textValue = this.$('#pasg2').val();
            UserData.set("paSmartGoal2", textValue);
            UserData.save();
		},

		findCheckinEvent: function() {
			console.log("activity goals view findCheckinEvent");
			var textValue = this.$('#pasgcid').val();
			console.log("for : " + textValue);

			mcmCalendar = new CalendarModel(calEventTitle, calEventNotes);
			mcmCalendar.findEvent(textValue);

			this.$('#pasgcid').val( mcmCalendar.suggestFutureDate(textValue) );

			console.log("activity goals view findCheckinEvent finished");
		},

		createCheckinEvent: function() {
			console.log("activity goals view createCheckinEvent");
			textValue = this.$('#pasgcid').val();
            UserData.set("activityGoalsCheckinDate", textValue);
            UserData.save();
            console.log("userdata saved - checkin date: " + textValue);

			mcmCalendar.createEvent(textValue);

			console.log("activity goals view createCheckinEvent finished");
		}

	});
	return PhysicalGoalsView;
});
