define(function(require) {
    var log = require("loglevel"),
        UserData = require("models/UserData"),
        pdfHelper = require("views/pdfHelperFunctions"),
	    Handlebars = require("handlebars"),
        pdfGenerator = require("utilities/pdfGenerator"),
        template = require("text!templates/foodPortions.html");

    var compiled_template = Handlebars.compile(template);

    var wrongAnswers = [];
    var portionsArray, foodsArray;

    var PortionsView = Backbone.View.extend({
        id: "foodPortionsView",

        events: {
        	"click #check-answer": "checkAnswer",
            "click #resourceListItem": "listItemTapped"
        },

		initialize: function() {
			this.listenToOnce(this.model, 'change:leftSlider', this.updateScale);
// pdfGenerator.buildPdf();
// pdfGenerator.pdfGen2();
//var sjbUrl =
var fname = "sjb.pdf";
 pdfGenerator.pdfGen3(fname);
 console.log("xxxx");
var file = cordova.file.documentsDirectory + fname;


			function resOnError32(error) {
    			alert("file error3: " + error.code);
			}

			function resOnSuccess(entry) {
				 console.log("xxxresonsuccessx");
				 console.log("entry", entry);
				 console.log("entryFP: ", entry.fullPath);
				 console.log("entryF name ", entry.name);
				 console.log("entryF url ", entry.toURL());

			pdfHelper.openPDF(entry.toURL());
			}

    		window.resolveLocalFileSystemURL(file, resOnSuccess, resOnError32);

			// console.log("logob: " +logOb);

// console.log("url: " + sjbUrl);
// pdfHelper.openPDF(sjbUrl);
			portionsArray = this.model.get ('portionList');
			foodsArray = this.model.get ('foodWithAnswerList');
			$.each(foodsArray, function(index, value) // is there a better way to do this?
			{
				wrongAnswers[index] = 0;
			});
			console.log("portionsArray: " + portionsArray);

			var that = this;

			Handlebars.registerHelper('getSliderPortions', function() {
				var listData = "";
				var imagePath = "images/icons/guides/guide2/"; // device path
				$.each (portionsArray, function(index, value)
				{
      				listData += "<div>";
      				listData += "<img u='image' src='" + imagePath + value[0] + "@2x.png' />";
      				listData += "</div>";
			  	});
			  	console.log("portion pics: " + listData);
			  	return new Handlebars.SafeString(listData);
			});


			Handlebars.registerHelper('getSliderFoods', function() {
				var listData = "";
				$.each (foodsArray, function(index, value)
				{
      				listData += "<div>";
      				// doesn't blow up
      				// listData += "<div>" + value[0] + "</div>";
      				// what i want to use but can't cause it blows up on device
      				// listData += "<h1 style='float: right; line-height: 600px; font-size: 500%; vertical-align: middle;'>" + value[0] + "</h1>";

      				listData += "<h1 style='float: right; font-size: 500%; margin-top: 300px; margin-right: 50px'>" + value[0] + "</h1>";
      				listData += "</div>";
			  	});
			  	console.log("food list: " + listData);
			  	return new Handlebars.SafeString(listData);
			});

			Handlebars.registerHelper('getPhoneOnlyDisplay', function() {
				return (isTablet) ? "none" : "block";
			});

		},

        render: function() {
            this.$el.html(compiled_template(this.model));

		    var renderDeferred = $.Deferred();

		 	var navDisplay = (isTablet) ? 2 : 1;
			// captions and/or transitions blow up on device
	     	var sliderOptions = {
            		$AutoPlay: false,                                    //[Optional] Whether to auto play, to enable slideshow, this option must be set to true, default value is false
            		$PlayOrientation: 2,                                //[Optional] Orientation to play slide (for auto play, navigation), 1 horizental, 2 vertical, 5 horizental reverse, 6 vertical reverse, default value is 1
            		$DragOrientation: 2,                                //[Optional] Orientation to drag slide, 0 no drag, 1 horizental, 2 vertical, 3 either, default value is 1 (Note that the $DragOrientation should be the same as $PlayOrientation when $DisplayPieces is greater than 1, or parking position is not 0)
					$HWA: false,										// disable hardware acceleration or image rotates 90* for some reason

            		$ArrowNavigatorOptions: {
                		$Class: $JssorArrowNavigator$,              //[Requried] Class to create arrow navigator instance
                		$ChanceToShow: navDisplay,                               //[Required] 0 Never, 1 Mouse Over, 2 Always
                		$AutoCenter: 0,                                 //[Optional] Auto center arrows in parent container, 0 No, 1 Horizontal, 2 Vertical, 3 Both, default value is 0
                		$Steps: 1,                                       //[Optional] Steps to go for each navigation request, default value is 1
            			$Scale: false							//setting this to false seems to make the arrows disappear :(
            		}
    		};


	     	var that = this;

	     	require(["text!templates/foodPortions.html"], function(template) {
				console.log("in require SJB - resolving deferred");
				//this is necessary to ensure the DOM is populated with the containers prior to instantiating the slider objects below.  Otherwise the app will crash.
				renderDeferred.resolve();

	     	});
	     	$.when(renderDeferred).done(function() {
			    console.log("render deferred done");
				var leftSliderObject = new $JssorSlider$("pleftSlider_container", sliderOptions);
				var rightSliderObject = new $JssorSlider$("prightSlider_container", sliderOptions);

				//this causes the scale method to be triggered
				that.model.set({'leftSlider':leftSliderObject, 'rightSlider':rightSliderObject});

				if (that.model.get('leftSliderCurrentIndex') != "not set") {
					leftSliderObject.$GoTo(that.model.get('leftSliderCurrentIndex'));
					that.model.set({'leftSliderCurrentIndex': "not set"});
				} else {
					leftSliderObject.$GoTo(0);
				}
				if (that.model.get('rightSliderCurrentIndex') != "not set") {
					rightSliderObject.$GoTo(that.model.get('rightSliderCurrentIndex'));
					that.model.set({'rightSliderCurrentIndex': "not set"});
				} else {
					rightSliderObject.$GoTo(0);
				}

				// displays text of picture
				rightSliderObject.$On($JssorSlider$.$EVT_PARK, function(slideIndex, fromIndex)
				{
					var portionText = portionsArray[slideIndex][1];
					$("#pictureText").html(portionText);
				});

	     	});  // end deferred

			$(this.el).trigger("create");
            return this;
        },

		/*
		 * This method will scale the slider images to the correct width to fill the width of the device screen. Aspect ratio is preserved and height is based on width
		 */
		// copied from PhotosView.js
		updateScale: function() {
			console.log("updateScale");
            var windowWidth = $(window).width();
            if (windowWidth) {
              	var leftSlider = this.model.get('leftSlider');
             	var rightSlider = this.model.get('rightSlider');

                var windowHeight = $(window).height();

                var scaleWidth = windowWidth;

               	var originalWidth = leftSlider.$GetOriginalWidth();
               	var originalHeight = leftSlider.$GetOriginalHeight();

               	if (originalWidth / windowWidth < originalHeight / windowHeight) {
               	    scaleWidth = Math.ceil(windowHeight / originalHeight * originalWidth);
               	}

				scaleWidth = scaleWidth/2.25;

				leftSlider.$SetScaleWidth(scaleWidth);
                rightSlider.$SetScaleWidth(scaleWidth);
            }
            else {
                 window.setTimeout(this.updateScale, 30);
        	}

		},

        checkAnswer: function() {
			var msg;
			var msgTitle;

          	var foodIndex = this.model.get('leftSlider').$CurrentIndex();
         	var portionIndex = this.model.get('rightSlider').$CurrentIndex();

			var answer = foodsArray[foodIndex][1];
			console.log("correct answer: " + answer);

			if (answer == portionIndex)
			{
				msgTitle = "Correct!!";
				wrongAnswers[foodIndex] = 0;
			}
			else
			{
				msgTitle = "Incorrect";
				wrongAnswers[foodIndex]++;
			}

			if (wrongAnswers[foodIndex] > 0 && wrongAnswers[foodIndex] < 3)
			{
				msg = 'Please review the "Serving Sizes" handout and try again.';
			}
			else
			{	// either the correct answer or too many wrong answers for this food
				wrongAnswers[foodIndex] = 0;
				msg = this.getCorrectAnswerMessage(foodsArray[foodIndex]);
			}


			if ( typeof navigator.notification == 'undefined') {
				alert(msgTitle +"\n" + msg); // fallback for browser or bad plugin
			} else {
				navigator.notification.alert(
					msg,
					null, // callback
					msgTitle, // title
					'OK' // buttonName
				);
			}
        },

		// One serving of %@ is equivalent in size to
        getCorrectAnswerMessage: function(aFoodItem) {
			var portion = portionsArray[aFoodItem[1]][2];
        	var msg = "One serving of " + aFoodItem[0] + " is equivalent in size to " + portion + ".";
        	return msg;
		},

       	// is there a way to call this from the events section rather than doing this?
        listItemTapped: function (event) {
        	pdfHelper.openHandoutsPDF(event);
        }

    });

    return PortionsView;
});
