define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/userInfo.html"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);
    
    var genderString = "";
        
        if (UserData.get("initialGender")){
        	genderString = UserData.get("initialGender");
        }else{
        	genderString = "Female";
        	UserData.set("initialGender",genderString);
        }
    
	var UserInfoView = Backbone.View.extend({
        id: "userInfoView",

        templateName: "userInfo.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
              // "change #joinedMOVE1": "saveJoinedMOVEData",
              // "change #joinedMOVE2": "saveJoinedMOVEData",
              // "change #MOVE_Hope1": "saveJoinedMOVEData",
              // "change #MOVE_Hope2": "saveJoinedMOVEData"  
              // "change #genderSwitch": "saveUserInfoData"
              "click #heightCell": "heightSelect",
              // "click #weightCell": "weightSelect",
              // "click #genderCell": "genderSelect",
              
              "change #genderSelect": "genderSelect",
              "click #ageCell": "ageSelect",
              "load #headerText": "selectHeader"
           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);
			
			

		},
		
		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);
        	
        	//do we need both these lines?
        	//this.videoTemplate = compiled_template(this.model);
        	
            this.$el.html(compiled_template(this.model.toJSON()));
           
           if (genderString === "Female") {
				this.$('#genderSelect').replaceWith('<select name="genderSelect" id="genderSelect" title="Select Gender">\
				<option value="Female" selected="selected">Female</option>\
				<option value="Male">Male</option>\
			</select>');
			}else if (genderString === "Male") {
				this.$('#genderSelect').replaceWith('<select name="genderSelect" id="genderSelect" title="Select Gender">\
				<option value="Female">Female</option>\
				<option value="Male" selected="selected">Male</option>\
			</select>');
			}
			
            return this;
		},/*
		heightSelect: function(){
			var heightValue = prompt('Enter height in inches');
			
			// $(#heightValue).html(heightValue);
			
			// var textValue = this.$('#heightValue').val();
             UserData.set("initialHeight", heightValue);
             
             UserData.save();
		},*/
		/*weightSelect: function(){
			var weightValue = prompt('Enter weight in pounds (lbs)');
			
			UserData.set("initialWeight", weightValue);
             
             UserData.save();
		},*/
		genderSelect: function(){
			// var genderValue = prompt('Enter gender');
			
			genderString = this.$("#genderSelect").val();
			
			UserData.set("initialGender", genderString);
			 
            UserData.save();
		},
		/*ageSelect: function(){
			var ageValue = prompt('Enter your age to the nearest year');
			
			UserData.set("initialAge", ageValue);
             
             UserData.save();
		},*/
		selectHeader: function(){
			if(UserData.get("firstTimeEntriesComplete") !== true){
				$('#headerText').html("Please enter the following:");
			}else{
				$('#headerText').html("Welcome to MOVE! Coach, the following entries are required.");
			}
		}
		// ,
// 		
		 // saveUserInfoData: function(){
			 // var textValue = this.$('#heightValue').val();
             // UserData.set("initialHeight", textValue);
// //             
            // // textValue = this.$('#joinedMOVE2').val();
            // // UserData.set("joinedMOVE2", textValue);
// //             
            // // textValue = this.$('#MOVE_Hope1').val();
            // // UserData.set("changeWillHelp1", textValue);
// //             
            // // textValue = this.$('#MOVE_Hope2').val();
            // // UserData.set("changeWillHelp2", textValue);
// // 			
			 // UserData.save();
		 // }
		
		
		// showTranscript: function() {
// 			
			// defaultRouter.navigate("#transcript/" + this.model.transcriptLink, {
                // trigger: true, replace:false
            // });
			// console.log ("show transcript: " + this.model.transcriptLink);
		// }
	});
	return UserInfoView;
});