define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/weightLossTargetEntry.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);
    var wtClear = true;
    var textString = "";

        if (UserData.get("initialTargetWeight")){
        	textString = UserData.get("initialTargetWeight");
        }

    var TargetWeightEntryView = Backbone.View.extend({
        id: "weightLossTargetEntryView",

        templateName: "weightLossTargetEntry.html",

           events: {
              // // "click #transcriptButton": "showTranscript"
               // "change #weightInput": "changeTargetWeight"
              "click #doneButton": "changeTargetWeight",
              "click #button1": "button1Select",
              "click #button2": "button2Select",
              "click #button3": "button3Select",
              "click #button4": "button4Select",
              "click #button5": "button5Select",
              "click #button6": "button6Select",
              "click #button7": "button7Select",
              "click #button8": "button8Select",
              "click #button9": "button9Select",
              "click #buttonDot": "buttonDotSelect",
              "click #button0": "button0Select",
              "click #buttonDelete": "buttonDeleteSelect"
           },

initialize: function() {
			console.log ("initializing userInfo view: " + this);

		},

		render: function() {
			log.debug ("calling render in userInfo view with template name: " + this.templateName);


            this.$el.html(compiled_template(this.model.toJSON()));
            wtClear = true;

            textString = "";

        if (UserData.get("initialTargetWeight")){
        	textString = UserData.get("initialTargetWeight");
        }

            this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'>" + textString + "</span>");

            return this;
		},

		changeTargetWeight: function(){

            // var targetValue = this.$('#weightInput').val();
			var targetValue = textString;

			var baselineWeight = UserData.get("initialWeight");

			var poundsValue = Number(baselineWeight) - Number(targetValue);

			var percentValue = (Number(poundsValue) / Number(baselineWeight)) * 100.0;

			poundsValue = Number(poundsValue).toFixed(1);
			percentValue = Number(percentValue).toFixed(1);
			targetValue = Number(targetValue).toFixed(1);

             UserData.set("initialLBSToLose", poundsValue);
             UserData.set("initialPercentToLose", percentValue);
             UserData.set("initialTargetWeight", targetValue);

			UserData.save();
		},
		button1Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('1');
			// UserData.set("initialPercentToLose", text);
			// UserData.save();
			textString = textString + "1";
			console.log("text value: " + textString);
		},
		button2Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('2');
			textString = textString + "2";
			console.log("text value: " + textString);
		},
		button3Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('3');
			textString = textString + "3";
			console.log("text value: " + textString);
		},
		button4Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('4');
			textString = textString + "4";
			console.log("text value: " + textString);
		},
		button5Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('5');
			textString = textString + "5";
			console.log("text value: " + textString);
		},
		button6Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('6');
			textString = textString + "6";
			console.log("text value: " + textString);
		},
		button7Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('7');
			textString = textString + "7";
			console.log("text value: " + textString);
		},
		button8Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('8');
			textString = textString + "8";
			console.log("text value: " + textString);
		},
		button9Select: function(){
			if(wtClear === true){
				wtClear = false;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}

			var text = this.$('#lbsDisplay').append('9');
			textString = textString + "9";
			console.log("text value: " + textString);
		},
        buttonDotSelect: function(){
			if(wtClear === true || textString.length === 0){
				wtClear = true;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}else{
			var text = this.$('#lbsDisplay').append('.');
			textString = textString + ".";
			}

			console.log("text value: " + textString);
		},
		button0Select: function(){
			if(wtClear === true || textString.length === 0){
				wtClear = true;
				this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'></span>");
				textString = "";
			}else{
			var text = this.$('#lbsDisplay').append('0');
			textString = textString + "0";
			}

			console.log("text value: " + textString);
		},
		buttonDeleteSelect: function(){
			// var text = UserData.get("initialPercentToLose");
			textString = textString.substring(0, textString.length-1);

			console.log("text value: " + textString);

			this.$('#lbsDisplay').replaceWith("<span id='lbsDisplay'>" + textString + "</span>");
			// alert('initial text: ' + text.val());
			// alert('spliced text: ' + text.splice(0, -1));
			// text = text.;
			// this.$('#lbsDisplay').html("<span id='lbsDisplay'>" + text + "</span>");
		}
    });

    return TargetWeightEntryView;
});
