define(function(require) {
    var log = require("loglevel");

    var EventData = Backbone.Model.extend({
        localStorage: new Backbone.LocalStorage("chainOfEventsData"),

        deferred: "",
        
		defaults:  {
			"problemDescription":[],
			"eventChain":[]			
// 			"eventChain":[ { event: "", options: [] }]			
		},

	    initialize: function() {
	    	
            // Fetch user data from local storage
            this.deferred = this.fetch({                          
                reset: true                           
            });
            
            this.on("reset", function(e) {
                this.deferred.resolve();
            });
        },

        parse: function(response) {
            return response[0];
        },

        clear: function() {
		}, 
		
		reset: function () {
			this.save();	
		},
		
		addEventItemToList: function(listName, item) {
			
			var list = this.get (listName);
			var event = { event: item, options: [] };
			
			list.push(event);
			this.save();
		},

		addOptionToEvent: function(listName, eventIndex, item) {
			
			var eventList = this.get(listName);
			var event = eventList[eventIndex];

			event.options.push(item);
			this.save();
		},

		replaceEventNameInList: function(listName, eventIndex, item) {
			var eventList = this.get(listName);
			var event = eventList[eventIndex];

			event.event = item;
			this.save();
		},

		replaceOptionInEvent: function(listName, eventIndex, optionIndex, item) {
			var eventList = this.get(listName);
			var event = eventList[eventIndex];

			event.options[optionIndex] = item;
			this.save();
		},

		removeOptionFromEventList: function(listName, eventIndex, index) {
						
			var eventList = this.get(listName);
			var event = eventList[eventIndex];
			var list = event.options;

			return (this.removeItem(list, index));
		},

		removeItemFromList: function(listName, index) {

			var list = this.get(listName);
			return (this.removeItem(list, index));
		},

		// "private" method
		removeItem: function( aList, index ) {

			var returnVal = true;
			if (index >= aList.length) {
				returnVal = false;
			} else {

				aList.splice(index, 1);			
				this.save();
			}
			return returnVal;
		}

		
	});
		
  	var eventData = new EventData();
    return eventData;
});