define(function(require) {
    var log = require("loglevel");

    var ShakeGameModel = Backbone.Model.extend({
    	
    	defaults: {
			
    	},
		
		G1C1List:  [  "You will feel better! Set a goal to lose 10% and ‘Go For It’",
                      "Improves your ability to move and do activities. Losing weight makes every step and breath easier.", 
                      "Reduces blood pressure. Even a small weight loss can help to lower high blood pressure.", 
                      "Reduces the risk of developing diabetes and helps control blood sugar levels if you are already diabetic.", 
                      "Lowers the risks of heart disease, heart attacks, and stroke.", 
                      "Puts less stress on your bones and joints, especially the knees.", 
                      "Reduces the risks of some types of cancer. A healthy weight and a healthy diet with plenty of vegetables, fruits, and whole grains are great ways to reduce your risk of developing certain cancers.", 
                      "Lowers the risk of congestive heart failure. Excess weight puts stress on the heart and lungs.", 
                      "Lowers the risk of sleep apnea, a serious breathing difficulty during sleep.", 
                      "Lowers the risk of developing gallstones and having gallbladder disease."
				   ],
		G5C3List:  [	
	                  "Go for a walk",
                      "Go fishing",
                      "Go hiking",
                      "Walk with a friend",
                      "Visit a museum or gallery",
                      "Go dancing",
                      "Go to the park",
                      "Go to the gym and work out",
                      "Go bird watching",
                      "Walk on the beach",
                      "Swim in a lake",
                      "Go boating or canoeing",
                      "Go Kayaking",
                      "Go for a bike ride",
                      "Play golf",
                      "Play tennis",
                      "Go for a run",
                      "Take your dogs(s) out",
                      "Take your neighbors dogs out",
                      "Go mall walking",
                      "Go window shopping",
                      "Play basketball",
                      "Start a woodworking project",
                      "Wash your car",
                      "Cut your grass",
                      "Cut your neighbors grass",
                      "Run errands",
                      "Do yoga",
                      "Go to a yoga class",
                      "Take your child or grandchild to the playground",
                      "Clean your house",
                      "Mop the floors",
                      "Wash the windows",
                      "Garden",
                      "Rake leaves",
                      "Do jumping jacks",
                      "Jump rope",
                      "Do squats (15)",
                      "Do lunges (10 per leg)",
                      "Do calf raises/stretch (10 per leg)",
                      "Walk to a friend’s home",
                      "Do sit-ups (10)",
                      "Do push-ups (5)"
					],
       
		initialize: function(gameId) {
			console.log("initializing a new shake game model with gameId: " + gameId);
			this.gameId = gameId;
			switch(this.gameId) {
				case "1":
					// copy original array, and let underscore shuffle it
					this.shakeWords = _.shuffle(this.G1C1List.slice(0));
					this.shakeInstructions = "Shake your device or touch the button below to learn about 10 Health Gains from a 10% Weight Loss!";
					this.buttonText = "Go";
					break;
				case "2":
					// copy original array, and let underscore shuffle it
					this.shakeWords = _.shuffle(this.G5C3List.slice(0));
					this.shakeInstructions = "Shake your device or touch the button below to see some activity suggestions.";
					this.buttonText = "Go";
					break;
				default:
					this.shakeWords = [];
					this.shakeInstructions = "No shake game configured for guide " + this.gameId;
					break;
			}
		
		},

		nextWord: function() {
			console.log("nextWord()");
			if ( !this.shakeWords.length )
			{
				this.initialize( this.gameId );
			}
			var word = "" + this.shakeWords.length + ":  " + this.shakeWords.shift();
			return word;
		},

		// Needs to be called after nextWord() to get correct text
		nextButton: function() {
			console.log("nextButton()");
			var buttonText = "Next";
			if ( !this.shakeWords.length )
			{
				buttonText = "Start Over";
			}
			return buttonText;
		}

	});

	return ShakeGameModel;
});