define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        EventData = require("models/ChainOfEventsModel"),
        template = require("text!templates/G10C2ChainOfEvents-3.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // remember which option was selected for helper to display checkmark
    var selectedOptionIdx = -1, selectedEventIdx = -1;

    var G10C2ChainOfEvents3View = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "G10C2ChainOfEvents3View",

		model: EventData,

		initialize: function() {

			Handlebars.registerHelper( 'isEventOptionSelected', function(eventIdx, optionIdx, options) {
				if (eventIdx == selectedEventIdx && optionIdx == selectedOptionIdx) {
					return "true";
				} else {
					return "false";
				}
			});
		},

        events: {
            'click ul#eventOptionsListView li#selectableCells': function(ev){this.getIndexAndRemoveOption(ev);},
        },

        render: function() {

            $(this.el).html(compiled_template(EventData.toJSON()));

            return this;
        },

		getIndexAndRemoveOption: function (ev) {
			var eventName = ev.target.parentElement.parentElement.getAttribute("data-event");
			var eventOption = ev.target.textContent;

			selectedOptionIdx = ev.target.parentElement.getAttribute("data-option-idx");
			selectedEventIdx = ev.target.parentElement.getAttribute("data-event-idx");

			var titleString = "Report";
			var message = "The problem you had is: " + EventData.get("problemDescription") + ".\n";
			message += "You can break the chain of events leading to this problem by replacing this event: " + eventName + "\n";
			message += "with this option: " + eventOption + ".";

			// wants to use slide for transition, so change temporarily
			var xitn = $.mobile.changePage.defaults.transition;
			$.mobile.changePage.defaults.transition = "none";
			Backbone.history.loadUrl();
			$.mobile.changePage.defaults.transition = xitn;

			if ( typeof navigator.notification == 'undefined') {
				alert(titleString + "\n" + message);
			} else {
				navigator.notification.alert(
					message,
					null,           // callback
					titleString,    // title
					"OK"     // buttonLabels
				);
			}
		}
    });

    return G10C2ChainOfEvents3View;
});
