define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G2C3PlateSliders.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var value1;
	var value2;
    var value3;
    // The view for Guide 1 Quesionnaire
    var G2C3PlateSlidersView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g2C3PlateSlidersView",


        events: {
            'click #slidersComplete': 'generateReport',
            'change #slider-1': 'slider1change',
            'change #slider-2': 'slider2change',
            'change #slider-3': 'slider3change',
            'click #test-data-button': 'populateTestData',
            "click #previous-button": "handlePreviousButton"
        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));
            // $(this.el).attr('data-role', 'page');

            value1 = 0;
            value2 = 0;
            value3 = 0;

			$('#next-button').replaceWith('<div id="next-button"></div>');

            return this;
        },
        slider1change: function() {
        	value1 = this.$('#slider-1').val();
        	this.$('#VegAndFruitText').replaceWith('<span id="VegAndFruitText">' + value1 + '</span>');
        },
        slider2change: function() {
        	value2 = this.$('#slider-2').val();
        	this.$('#GrainsText').replaceWith('<span id="GrainsText">' + value2 + '</span>');
        },
        slider3change: function() {
        	value3 = this.$('#slider-3').val();
        	this.$('#MeatText').replaceWith('<span id="MeatText">' + value3 + '</span>');
        },

        generateReport: function() {
            // Save changes to local storage.

            this.$('#viewReport').replaceWith('<div id="viewReport"></div>');
            this.$('#localFooter').replaceWith('<div id="localFooter"></div>');

            var message = "Your plate was filled by:\n" + value1 + "% Vegetables & Fruit\n" + value2 + "% Grains & Starchy Vegetables\n" + value3 + "% Lean Meat & Other Proteins\n\nMOVE! Recommends the following:\n50% Vegetables & Fruit\n25% Grains & Starchy Vegetables\n25% Lean Meat & Other Proteins";

            // var HTMLmessage = "<p>Your plate was filled by:<br />" + value1 + "% Vegetables & Fruit<br />" + value2 + "% Grains & Starchy Vegetables<br />" + value3 + "% Lean Meat & Other Proteins<br /><br />MOVE! Recommends the following:<br />50% Vegetables & Fruit<br />25% Grains & Starchy Vegetables<br />25% Lean Meat & Other Proteins";

            // this.$('#viewReport').replaceWith('<div id="viewReport">' + HTMLmessage + '</div>');


            // alert(message);


				navigator.notification.alert(
                message,    // message
                null,       // callback
                "Your Plate Report", // title
                'OK'        // buttonName
            );


        }
    });

    return G2C3PlateSlidersView;
});
