define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G3GetReady.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for Guide 1 Quesionnaire
    var SurveyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g3GetReadyView",


        events: {
            'click #surveyComplete': 'storeSurveyData'

        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            var value1 = 0;

            if(SurveyData.get("weightControlImportance")){
            	value1 = SurveyData.get("weightControlImportance");
            }

            var value2 = 0;

            if(SurveyData.get("changeConfidence")){
            	value2 = SurveyData.get("changeConfidence");
            }

            this.$('#wciText').replaceWith('<p id="wciText" style="margin-left: auto; margin-right: auto;width: 10%">' + value1 + '</p>');

            this.$('#confText').replaceWith('<p id="confText" style="margin-left: auto; margin-right: auto;width: 10%">' + value2 + '</p>');

            return this;
        },

        storeSurveyData: function() {
            // Save changes to local storage.


			// record the selected support/encouragement value, if any
			var soda = $("#sodaListFieldSet input:checked").val();
            SurveyData.set("soda", soda);

			// recording what was selected into main encouragementList
			// so it can be displayed as selected
			var sodaField = $("#sodaListFieldSet input:checked")[0];
			if (typeof sodaField != 'undefined')
			{
				var sfKey = sodaField.id;
				var snList = SurveyData.get("sodaList");
				for (i=0; i < snList.length; i++)
				{
                	if (snList[i].value == sfKey)
					{
						snList[i].checked = true;
					}
					else
					{
						snList[i].checked = false;
					}
           		}
			}


			// record the selected support/encouragement value, if any
			var alcohol = $("#alcoholListFieldSet input:checked").val();
            SurveyData.set("alcohol", alcohol);

			// recording what was selected into main encouragementList
			// so it can be displayed as selected
			var alcoholField = $("#alcoholListFieldSet input:checked")[0];
			if (typeof alcoholField != 'undefined')
			{
				var afKey = alcoholField.id;
				var anList = SurveyData.get("alcoholList");
				for (i=0; i < anList.length; i++)
				{
                	if (anList[i].value == afKey)
					{
						anList[i].checked = true;
					}
					else
					{
						anList[i].checked = false;
					}
           		}
			}

			// record the selected support/encouragement value, if any
			var binge = $("#bingeListFieldSet input:checked").val();
            SurveyData.set("binge", binge);

			// recording what was selected into main encouragementList
			// so it can be displayed as selected
			var bingeField = $("#bingeListFieldSet input:checked")[0];
			if (typeof bingeField != 'undefined')
			{
				var bfKey = bingeField.id;
				var bnList = SurveyData.get("bingeList");
				for (i=0; i < bnList.length; i++)
				{
                	if (bnList[i].value == bfKey)
					{
						bnList[i].checked = true;
					}
					else
					{
						bnList[i].checked = false;
					}
           		}
			}



			// // record the selected issues
			// var issuesField = $("#issuesListFieldSet input:checked");
            // var selectedIssues = [];
            // for (i=0; i < issuesField.length; i++)
            // {
                // selectedIssues[i] = issuesField[i].value;
            // }
//
            // // alert(selectedIssues);
//
            // SurveyData.set("surveyIssues", selectedIssues);
//
            // // there has to be a better way to do this
			// // recording what was selected into the main issuesList
			// // so it can be displayed as checked
			// var issuesKey;	// more performant?
			// var issues = SurveyData.get("issuesList");
			// for (i=0; i < issues.length; i++)
			// {
				// issues[i].checked = false;
				// issuesKey = issues[i].name;
	            // for (j=0; j < selectedIssues.length; j++)
	            // {
	            	// if (selectedIssues[j] == issuesKey)
					// {
						// issues[i].checked = true;
						// break;
					// }
	       		// }
            // }


            SurveyData.save();
			Guides.get(3).save("getReadyComplete", "check");

			Backbone.history.history.back();

//             defaultRouter.navigate("#guide/1", {
//                 trigger: true, replace:true
//             });
        }
    });

    return SurveyView;
});
