define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/G8C1MakePlan.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

	var selected_index;

    // The view for Guide 1 Quesionnaire
    var G8C1MakePlanView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "g8C1MakePlanView",


        events: {

            'change #planButton': 'planEntry',
            'change #rewardButton': 'rewardEntry',
            'swipeleft ul#planList li#deletableCells': 'getIndex',
            'swiperight ul#planList li#deletableCells': 'getIndex'


        },

        render: function() {
            $(this.el).html(compiled_template(UserData.toJSON()));

            var planEntry = [];

             if(UserData.get("G8C1PlanEntrys")){
             	var pulledPlan = UserData.get("G8C1PlanEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}


             	for(var i=0; i < planEntry.length; i++){

             		this.$("#planList").append('<li id="deletableCells"><h2 id="textString">' + planEntry[i].planName + '</h2><p>Reward: ' + planEntry[i].subtitle + '</p></li>');

             	}

             }

             	UserData.set("G8C1PlanEntrys", planEntry);

             	UserData.save();

            return this;
        },
        getIndex: function(ev){

        	// gets index of selected cell
        	selected_index = $(ev.currentTarget).index();

        	var planEntry = [];

        	if(UserData.get("G8C1PlanEntrys").length > 0){
        		var pulledPlan = UserData.get("G8C1PlanEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}

             }

        	var titleString = 'Are you sure you want to delete ' + planEntry[selected_index - 1].planName + '?';

             	function onConfirm(buttonIndex) {
  					  if(buttonIndex === 1){

             	planEntry.splice(selected_index - 1,1);

             	UserData.set("G8C1PlanEntrys",planEntry);
             	UserData.save();

             	$(ev.currentTarget).remove();

					}
					}

				navigator.notification.confirm(
    				' ', // message
     				onConfirm,            // callback to invoke with index of button pressed
    				titleString,           // title
    				['Yes','No']     // buttonLabels
					);

        },
        rewardEntry: function(){
        	setTimeout(function(){

				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#rewardButton";
       				var listID = "#rewardList";

					var value = this.$(textFieldID).val();

					if (value != "") {

					// add reward functionallity here
        			UserData.set("G8C1CurrentReward",value);
        			UserData.save();

        			// save to array
        			var planEntry = [];

             if(UserData.get("G8C1PlanEntrys")){
             	var pulledPlan = UserData.get("G8C1PlanEntrys");

             	for(var i=0; i < pulledPlan.length; i++){
             		console.log(pulledPlan[i]);
             		planEntry[i] = pulledPlan[i];
             	}


             	planEntry[planEntry.length] = {planName: UserData.get("G8C1CurrentPlan"), subtitle: UserData.get("G8C1CurrentReward")};
             }else{
             	planEntry[0] = {planName: UserData.get("G8C1CurrentPlan"), subtitle: UserData.get("G8C1CurrentReward")};
             }

             		var plan = UserData.get("G8C1CurrentPlan");
             		var reward = UserData.get("G8C1CurrentReward");

             	this.$("#planList").append('<li id="deletableCells" style="background-color: white; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgba(0,0,0,0.1);border-top-width: 1px; border-top-style: solid; border-top-color: rgba(0,0,0,0.1);"><h2 id="textString" style="margin-left:15px;">' + plan + '</h2><p style="margin-left:15px;">Reward: ' + reward + '</p></li>');

             	UserData.set("G8C1PlanEntrys", planEntry);

             	UserData.save();

					
					this.$("#reward").hide();
        			this.$("#plan").show("slow");
        			this.$(textFieldID).val('');
					this.$("#planList").listview("refresh");
        			
					}
					
				}
				

				}, 100);
        },
        
        planEntry: function(){
        	
        	setTimeout(function(){

				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#planButton";
       				var listID = "#planList";

					var value = this.$(textFieldID).val();

					if (value != "") {

						this.$(textFieldID).val('');
				
					UserData.set("G8C1CurrentPlan",value);
        			UserData.save();

					this.$("#plan").hide();
        			this.$("#reward").show("slow");
					}
					
				}
				

				}, 100);

        }
    });

    return G8C1MakePlanView;
});
