define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        TriggersAndFixesData = require("models/TriggersAndFixesModel"),
        template = require("text!templates/G9C2ConsiderEnvironment.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);
    
    var isEditing = false;
    var selectedIndex;

    // The view for Guide 1 Quesionnaire
    var G9C2ConsiderEnvironmentView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "G9C2ConsiderEnvironmentView",

		model: TriggersAndFixesData,

		initialize: function() {

			this.isClearing = false;
		},

        events: {

            'click .clearable>.ui-input-has-clear>.ui-input-clear': function(ev) {console.log ("generic clear was tapped"); this.isClearing=true;},
            'click #doneButton': 'fixesDone',
            
            'click ul#triggersListView li#deletableCells': function(ev){this.getIndexAndEdit(ev,"triggers");},

            'change #triggers': function(ev){this.fieldChange1(ev, "triggers", "triggersListView", "triggers");},
            'change #unhealthyFoods': function(ev){this.fieldChange(ev, "unhealthyFoods", "unhealthyFoodsListView", "unhealthyFoods");},
            'change #fixes': function(ev){this.fieldChange(ev, "fixes", "fixesListView", "fixes");},
            
			'swipeleft ul#triggersListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "triggers");},
            'swiperight ul#triggersListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "triggers");},
            
            'swipeleft ul#fixesListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "fixes");},
            'swiperight ul#fixesListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "fixes");},

            'swipeleft ul#unhealthyFoodsListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "unhealthyFoods");},
            'swiperight ul#unhealthyFoodsListView li#deletableCells': function(ev){this.getIndexAndRemove(ev, "unhealthyFoods");},

            
        },

        render: function() {
            $(this.el).html(compiled_template(TriggersAndFixesData.toJSON()));


            var self = this;
            
            
            var enteredTriggers = [];
			var enteredFixes = [];
			
			
			this.$('ul#triggersListView li#deletableCells').remove();
       		// this.$('#triggersListView').listview("refresh");
       		
			if(TriggersAndFixesData.get("triggers")){
             	var pulledTriggers = TriggersAndFixesData.get("triggers");

             	for(var i=0; i < pulledTriggers.length; i++){
             		
             		console.log(pulledTriggers[i]);
             		enteredTriggers[i] = pulledTriggers[i];
             		
             		var codeString = '<li id="deletableCells"><h3>' + enteredTriggers[i].trigger + '</h3><p>Fixes:<br/>';
             		
             		if(enteredTriggers[i]){
             	var pulledFixes = enteredTriggers[i].fixes;
             	
             	for (var j = 0; j < pulledFixes.length; j++){
             		console.log(pulledFixes[j]);
             		enteredFixes[j] = pulledFixes[j];
             		codeString = codeString + enteredFixes[j] + '<br />';
             	}
             }
             codeString = codeString + '</p></li>';
            	
            	this.$('#triggersListView').append(codeString);
             	}
             }
             
                // this.$('#triggersListView').listview("refresh");          



		/*	if (TriggersAndFixesData.get("triggers")){
            var triggers = TriggersAndFixesData.get("triggers");
            // var fixes = TriggersAndFixesData.get ("fixes");
//             
            // {trigger: enteredTrigger, fixes:enteredFixes};
            
            for(var i = 0; i < triggers.length; i++){
            	var codeString = '<li id="deletableCells"><h3>' + triggers[i].trigger + '</h3><p>Fixes:<br/>';
            	for(var j = 0; j < triggers[i].fixes.length; j++){
            		codeString = codeString + triggers[i].fixes[j] + '<br />';
            	}
            	
            	codeString = codeString + '</p></li>';
            	
            	this.$('#triggersListView').append(codeString);
            }
           }*/
            /*$.each( triggers, function( key, value ) {
				$('<li id="deletableCells">').append(value).appendTo(self.$('#triggersListView'));
			});*/

            var unhealthyFoods = TriggersAndFixesData.get ("unhealthyFoods");
            $.each( unhealthyFoods, function( key, value ) {
				$('<li id="deletableCells">').append(value).appendTo(self.$('#unhealthyFoodsListView'));
			});
			
			this.$('#fixEntryPage').hide();


            return this;
        },

       	fieldChange: function (event, textFieldName, listName, arrayName ) {
       		


       		setTimeout(function(){

				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#"+textFieldName;
       				var listID = "#"+listName;

					var value = this.$(textFieldID).val();

					if (value != "") {

						$('<li id="deletableCells">').append(value).appendTo(this.$(listID));
						this.$(textFieldID).val('');
						this.$(listID).listview("refresh");

						TriggersAndFixesData.addItemToList(arrayName, value);
					}
					
				}
				

			}, 100);
       	},
       	fieldChange1: function (event, textFieldName, listName, arrayName ) {

       		setTimeout(function(){
       		
				if (this.isClearing) {
						this.isClearing=false;
				} else {

					var textFieldID = "#"+textFieldName;
       				var listID = "#"+listName;

					var value = this.$(textFieldID).val();

					if (value != "") {
						
						TriggersAndFixesData.set('currentTrigger',value);

						// $('<li id="deletableCells">').append(value).appendTo(this.$(listID));
						this.$(textFieldID).val('');
						this.$(listID).listview("refresh");

						// TriggersAndFixesData.addItemToList(arrayName, value);
						
						
						this.$('#initialPage').hide();
						this.$('#fixEntryPage').show();
						
					    this.$('#fixTriggerLabel').replaceWith('<label id="fixTriggerLabel" for="fixes" style="white-space: normal">Fixes for ' + value + '</label>');
					}
				}

			}, 100);
       	},
       	fixesDone: function(){
       		// save data here
       		
       		/*console.log(isEditing);
       		if (isEditing == true){
       			var trig = TriggersAndFixesData.get('triggers');
       			TriggersAndFixesData.set('currentTrigger',trig[selectedIndex - 1].trigger);
       			console.log(TriggersAndFixesData.get('currentTrigger'));
       			TriggersAndFixesData.set('fixes', trig[selectedIndex - 1].fixes);
       		}*/
       			var enteredTrigger = TriggersAndFixesData.get('currentTrigger');
       			
       			
       			enteredTrigger = TriggersAndFixesData.get('currentTrigger');
       		var enteredFixes = [];
       		

             if(TriggersAndFixesData.get("fixes")){
             	var pulledFixes = TriggersAndFixesData.get("fixes");

             	for(var i=0; i < pulledFixes.length; i++){
             		console.log(pulledFixes[i]);
             		enteredFixes[i] = pulledFixes[i];
             	}


             	var triggerWithFixes = {trigger: enteredTrigger, fixes:enteredFixes};
             	
             	TriggersAndFixesData.addItemToList("triggers", triggerWithFixes);
             	
             	


             }
       		
       		// reset fixes array
       		
       		TriggersAndFixesData.set('fixes',[]);
       		
       		TriggersAndFixesData.save();
       		
       		// clear displayed fixes
       		
       		this.$('ul#fixesListView li#deletableCells').remove();
       		this.$('#fixesListView').listview("refresh");
       		// show initialPage
       		this.$('#fixEntryPage').hide();
       		this.$('#initialPage').show();
			
			// update cells
			
            	var codeString = '<li id="deletableCells" style="background-color: white; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgba(0,0,0,0.1);border-top-width: 1px; border-top-style: solid; border-top-color: rgba(0,0,0,0.1);"><h2 style="margin-left:15px;">' + enteredTrigger + '</h2><p style="margin-left:15px;">Fixes:<br/>';
            	for(var j = 0; j < enteredFixes.length; j++){
            		codeString = codeString + enteredFixes[j] + '<br />';
            	}
            	
            	codeString = codeString + '</p></li>';
            	
            	this.$('#triggersListView').append(codeString);
            	
            	// this.$(textFieldID).val('');
						// this.$('#triggersListView').listview("refresh");
       		// }
            isEditing = false;
					    
       	},
       	getIndexAndEdit: function (ev, arrayName) {
       		
       		isEditing = true;
       		selectedIndex = $(ev.currentTarget).index();
       		
       		console.log("selected index=" + selectedIndex);
       		
       		var triggers = TriggersAndFixesData.get('triggers');
			
			var triggerTitle = triggers[selectedIndex - 1].trigger;
			
			TriggersAndFixesData.set('fixes',triggers[selectedIndex - 1].fixes);
			
			var enteredTriggers = [];
			
			
			if(TriggersAndFixesData.get("triggers")){
             	var pulledTriggers = TriggersAndFixesData.get("triggers");

             	for(var i=0; i < pulledTriggers.length; i++){
             		console.log(pulledTriggers[i]);
             		enteredTriggers[i] = pulledTriggers[i];
             	}
             }
             
             var enteredFixes = [];
             
             if(enteredTriggers[selectedIndex - 1]){
             	var pulledFixes = enteredTriggers[selectedIndex - 1].fixes;
             	
             	for (var i = 0; i < pulledFixes.length; i++){
             		console.log(pulledFixes[i]);
             		enteredFixes[i] = pulledFixes[i];
             	}
             }
			
			
			TriggersAndFixesData.set('fixes', enteredFixes);
			
			this.$('#initialPage').hide();
			this.$('#fixEntryPage').show();
			
			this.$('ul#fixesListView li#deletableCells').remove();
       		this.$('#fixesListView').listview("refresh");
       		
			
			this.$('#fixTriggerLabel').replaceWith('<label id="fixTriggerLabel" for="fixes" style="white-space: normal">Fixes for ' + triggerTitle + '</label>');
			
			
			
			var codeString = "";
            	for(var j = 0; j < enteredFixes.length; j++){
            		codeString = codeString + '<li id="deletableCells" style="background-color: white; border-bottom-width: 1px; border-bottom-style: solid; border-bottom-color: rgba(0,0,0,0.1);border-top-width: 1px; border-top-style: solid; border-top-color: rgba(0,0,0,0.1);"><h4>' + enteredFixes[j] + '</h4></li>';
            	}
            	
            	this.$('#fixesListView').append(codeString);
			// }
			var success = false;
					success = TriggersAndFixesData.removeItemFromList('triggers', selectedIndex-1);

					if (success) {
						$(ev.currentTarget).remove();
					}
					
       		
       	},

		getIndexAndRemove: function (ev, arrayName) {

			selectedIndex = $(ev.currentTarget).index();
			
			console.log("selected index=" + selectedIndex);
			
			var triggers = TriggersAndFixesData.get('triggers');
			
			
			
			if(arrayName == 'triggers'){
				var triggerTitle = triggers[selectedIndex - 1].trigger;
				var titleString = "Are you sure you want to delete " + triggerTitle;
			}else{
			    var titleString = "Are you sure you want to delete " + $(ev.currentTarget).text();
			}

			function onConfirm(buttonIndex) {
  				if (buttonIndex === 1) {

					//this accounts for the radio buttons in cell 0 and for the odd way that JQuery returns indexes starting at 1 instead of 0
					if (arrayName === "activityGoalChanges" || arrayName === "dietGoalChanges") {
						selectedIndex = selectedIndex-2;
					} else {
						selectedIndex = selectedIndex-1;
					}

					var success = false;
					success = TriggersAndFixesData.removeItemFromList(arrayName, selectedIndex);

					if (success) {
						$(ev.currentTarget).remove();
					}
				}
			}
			navigator.notification.confirm(
    			' ', // message
     			onConfirm,            // callback to invoke with index of button pressed
    			titleString,           // title
    			['Yes','No']     // buttonLabels
			);
		}
    });

    return G9C2ConsiderEnvironmentView;
});
