define(function(require) {
    var log = require("loglevel"),
	    Handlebars = require("handlebars"),
        UserData = require("models/UserData"),
        template = require("text!templates/heightEntry.html");

        var compiled_template = Handlebars.compile(template);

        var textString = "";

        if (UserData.get("initialHeight")){
        	textString = UserData.get("initialHeight");
        }

        var ftString = "5";

        if (UserData.get("heightFTComponent")){
        	ftString = UserData.get("heightFTComponent");
        }

        var inchString = "6";

        if (UserData.get("heightINComponent")){
        	inchString = UserData.get("heightINComponent");
        }

        //

    return Backbone.View.extend({
        id: "heightEntryView",

        templateName: "heightEntry.html",

           events: {

              "click #doneButton": "heightSelect",
              "change #ftSelect": "changeFeet",
              "change #inSelect": "changeInches"

           },

		initialize: function() {
			console.log ("initializing userInfo view: " + this);



		},

        render: function() {
            this.$el.html(template);

            this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');

			if(ftString === "3"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3" selected="selected">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "4"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4" selected="selected">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "5"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5" selected="selected">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "6"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6" selected="selected">6 ft</option><option id="7ft" value="7">7 ft</option></select>');
			}else if(ftString === "7"){
				this.$('#ftSelect').replaceWith('<select name="ftSelect" id="ftSelect"><option id="3ft" value="3">3 ft</option><option id="4ft" value="4">4 ft</option><option id="5ft" value="5">5 ft</option><option id="6ft" value="6">6 ft</option><option id="7ft" value="7" selected="selected">7 ft</option></select>');
			}



			this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');

            if(inchString === "0"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0" selected="selected">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "1"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1" selected="selected">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "2"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2" selected="selected">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "3"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3" selected="selected">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "4"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4" selected="selected">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "5"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5" selected="selected">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "6"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6" selected="selected">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "7"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7" selected="selected">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "8"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8" selected="selected">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "9"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9" selected="selected">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "10"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10" selected="selected">10 in</option><option id="11in" value="11">11 in</option></select>');
            }else if(inchString === "11"){
            	this.$('#inSelect').replaceWith('<select name="inSelect" id="inSelect"><option id="0in" value="0">0 in</option><option id="1in" value="1">1 in</option><option id="2in" value="2">2 in</option><option id="3in" value="3">3 in</option><option id="4in" value="4">4 in</option><option id="5in" value="5">5 in</option><option id="6in" value="6">6 in</option><option id="7in" value="7">7 in</option><option id="8in" value="8">8 in</option><option id="9in" value="9">9 in</option><option id="10in" value="10">10 in</option><option id="11in" value="11" selected="selected">11 in</option></select>');
            }

            return this;
        },
        heightSelect: function(){
			// var percentValue = this.$('#percentInput').val();;
			var ftValue = ftString;

			var total = (Number(ftString) * 12.0) + Number(inchString);

             UserData.set("heightFTComponent", ftString);
             UserData.set("heightINComponent", inchString);
             UserData.set("initialHeight", total);

             UserData.save();
		},
		changeFeet: function(){
			ftString = this.$("#ftSelect").val();
		},
		changeInches: function(){
			inchString = this.$("#inSelect").val();
		}
    });
});
