define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        template = require("text!templates/joinedMOVE.html"),
        UserData = require("models/UserData");

    var compiled_template = Handlebars.compile(template);

	var JoinedMOVEView = Backbone.View.extend({
        id: "joinedMOVEView",

        templateName: "joinedMOVE.html",

          events: {
              // "click #transcriptButton": "showTranscript"
              "change #joinedMOVE1": "saveJoinedMOVEData",
              "change #joinedMOVE2": "saveJoinedMOVEData",
              "change #MOVE_Hope1": "saveJoinedMOVEData",
              "change #MOVE_Hope2": "saveJoinedMOVEData"
          },

		initialize: function() {
			console.log ("initializing joinMOVE view: " + this);

		},

		render: function() {
			log.debug ("calling render in joinMOVE view with template name: " + this.templateName);

        	//do we need both these lines?
        	//this.videoTemplate = compiled_template(this.model);

            this.$el.html(compiled_template(this.model.toJSON()));
            return this;
		},

		saveJoinedMOVEData: function(){
			var textValue = this.$('#joinedMOVE1').val();
            UserData.set("joinedMOVE1", textValue);

            textValue = this.$('#joinedMOVE2').val();
            UserData.set("joinedMOVE2", textValue);

            textValue = this.$('#MOVE_Hope1').val();
            UserData.set("changeWillHelp1", textValue);

            textValue = this.$('#MOVE_Hope2').val();
            UserData.set("changeWillHelp2", textValue);

			UserData.save();
		}


		// showTranscript: function() {
//
			// defaultRouter.navigate("#transcript/" + this.model.transcriptLink, {
                // trigger: true, replace:false
            // });
			// console.log ("show transcript: " + this.model.transcriptLink);
		// }
	});
	return JoinedMOVEView;
});
