define(function(require) {
    var log = require("loglevel"),
        Handlebars = require("handlebars"),
        SurveyData = require("models/SurveyData"),
        Guides = require("collections/allGuides"),
        template = require("text!templates/survey.html");

    // Compile the template once.
    var compiled_template = Handlebars.compile(template);

    // The view for Guide 1 Quesionnaire
    var SurveyView = Backbone.View.extend({
        // Set the id attribute on the div.
        id: "surveyView",


        events: {
            'click #surveyComplete': 'storeSurveyData',
            'change #slider-1': 'slider1change',
            'change #slider-2': 'slider2change',
            'change #g1qil-13': 'noneClicked',
            'change #g1qil-01': 'otherClicked',
            'change #g1qil-02': 'otherClicked',
            'change #g1qil-03': 'otherClicked',
            'change #g1qil-04': 'otherClicked',
            'change #g1qil-05': 'otherClicked',
            'change #g1qil-06': 'otherClicked',
            'change #g1qil-07': 'otherClicked',
            'change #g1qil-08': 'otherClicked',
            'change #g1qil-09': 'otherClicked',
            'change #g1qil-10': 'otherClicked',
            'change #g1qil-11': 'otherClicked',
            'change #g1qil-12': 'otherClicked'


        },

        render: function() {
            $(this.el).html(compiled_template(SurveyData.toJSON()));

            var value1 = 0;

            if(SurveyData.get("weightControlImportance")){
            	value1 = SurveyData.get("weightControlImportance");
            }

            var value2 = 0;

            if(SurveyData.get("changeConfidence")){
            	value2 = SurveyData.get("changeConfidence");
            }

            this.$('#wciText').replaceWith('<p id="wciText" style="margin-left: auto; margin-right: auto;width: 10%">' + value1 + '</p>');

            this.$('#confText').replaceWith('<p id="confText" style="margin-left: auto; margin-right: auto;width: 10%">' + value2 + '</p>');

            return this;
        },
        slider1change: function() {
        	var value = this.$('#slider-1').val();
        	this.$('#wciText').replaceWith('<p id="wciText" style="margin-left: auto; margin-right: auto;width: 10%">' + value + '</p>');
        },
        slider2change: function() {
        	var value = this.$('#slider-2').val();
        	this.$('#confText').replaceWith('<p id="confText" style="margin-left: auto; margin-right: auto;width: 10%">' + value + '</p>');
        },
        noneClicked: function(){


	this.$('#g1qil-01').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-02').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-03').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-04').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-05').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-06').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-07').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-08').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-09').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-10').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-11').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-12').attr("checked", false).checkboxradio('refresh');

	this.$('#g1qil-13').attr("checked", true).checkboxradio('refresh');


        },
        otherClicked: function(){



	this.$('#g1qil-13').attr("checked", false).checkboxradio('refresh');


        },

        storeSurveyData: function() {
            // Save changes to local storage.
            var steve = this.$('#sjb1').val();
            SurveyData.set("steve", steve);

            var weightControlImportance = this.$('#slider-1').val();
            SurveyData.set("weightControlImportance", weightControlImportance);

            var changeConfidence = this.$('#slider-2').val();
            SurveyData.set("changeConfidence", changeConfidence);

			// record the selected support/encouragement value, if any
			var encouragement = $("#encouragementListFieldSet input:checked").val();
            SurveyData.set("supportExpected", encouragement);

			// recording what was selected into main encouragementList
			// so it can be displayed as selected
			var encouragementField = $("#encouragementListFieldSet input:checked")[0];
			if (typeof encouragementField != 'undefined')
			{
				var efKey = encouragementField.id;
				var enList = SurveyData.get("encouragementList");
				for (i=0; i < enList.length; i++)
				{
                	if (enList[i].value == efKey)
					{
						enList[i].checked = true;
					}
					else
					{
						enList[i].checked = false;
					}
           		}
			}

			// record the selected issues
			var issuesField = $("#issuesListFieldSet input:checked");
            var selectedIssues = [];
            for (i=0; i < issuesField.length; i++)
            {
                selectedIssues[i] = issuesField[i].value;
            }

            // alert(selectedIssues);

            SurveyData.set("surveyIssues", selectedIssues);

            // there has to be a better way to do this
			// recording what was selected into the main issuesList
			// so it can be displayed as checked
			var issuesKey;	// more performant?
			var issues = SurveyData.get("issuesList");
			for (i=0; i < issues.length; i++)
			{
				issues[i].checked = false;
				issuesKey = issues[i].name;
	            for (j=0; j < selectedIssues.length; j++)
	            {
	            	if (selectedIssues[j] == issuesKey)
					{
						issues[i].checked = true;
						break;
					}
	       		}
            }


            SurveyData.save();
			Guides.get(1).save("surveyComplete", "check");
			
console.log ("This is the survey view");

			Backbone.history.history.back();

//             defaultRouter.navigate("#guide/1", {
//                 trigger: true, replace:true
//             });
        }
    });

    return SurveyView;
});
